﻿
/*
	File Generated by NetTiers templates [www.nettiers.com]
	Important: Do not modify this file. Edit the file SqlObjectAclProvider.cs instead.
*/

#region using directives

using System;
using System.Data;
using System.Data.Common;
using System.Text;

using Microsoft.Practices.EnterpriseLibrary.Data;
using Microsoft.Practices.EnterpriseLibrary.Data.Sql;

using System.Collections;
using System.Collections.Specialized;

using System.Diagnostics;
using SecurityFoundation.Entities;
using SecurityFoundation.Data;
using SecurityFoundation.Data.Bases;

#endregion

namespace SecurityFoundation.Data.SqlClient
{
	///<summary>
	/// This class is the SqlClient Data Access Logic Component implementation for the <see cref="ObjectAcl"/> entity.
	///</summary>
	public abstract partial class SqlObjectAclProviderBase : ObjectAclProviderBase
	{
		#region Declarations
		
		string _connectionString;
	    bool _useStoredProcedure;
	    string _providerInvariantName;
			
		#endregion "Declarations"
			
		#region Constructors
		
		/// <summary>
		/// Creates a new <see cref="SqlObjectAclProviderBase"/> instance.
		/// </summary>
		public SqlObjectAclProviderBase()
		{
		}
	
	/// <summary>
	/// Creates a new <see cref="SqlObjectAclProviderBase"/> instance.
	/// Uses connection string to connect to datasource.
	/// </summary>
	/// <param name="connectionString">The connection string to the database.</param>
	/// <param name="useStoredProcedure">A boolean value that indicates if we should use stored procedures or embedded queries.</param>
	/// <param name="providerInvariantName">Name of the invariant provider use by the DbProviderFactory.</param>
	public SqlObjectAclProviderBase(string connectionString, bool useStoredProcedure, string providerInvariantName)
	{
		this._connectionString = connectionString;
		this._useStoredProcedure = useStoredProcedure;
		this._providerInvariantName = providerInvariantName;
	}
		
	#endregion "Constructors"
	
		#region Public properties
	/// <summary>
    /// Gets or sets the connection string.
    /// </summary>
    /// <value>The connection string.</value>
    public string ConnectionString
	{
		get {return this._connectionString;}
		set {this._connectionString = value;}
	}
	
	/// <summary>
    /// Gets or sets a value indicating whether to use stored procedures.
    /// </summary>
    /// <value><c>true</c> if we choose to use use stored procedures; otherwise, <c>false</c>.</value>
	public bool UseStoredProcedure
	{
		get {return this._useStoredProcedure;}
		set {this._useStoredProcedure = value;}
	}
	
	/// <summary>
    /// Gets or sets the invariant provider name listed in the DbProviderFactories machine.config section.
    /// </summary>
    /// <value>The name of the provider invariant.</value>
    public string ProviderInvariantName
    {
        get { return this._providerInvariantName; }
        set { this._providerInvariantName = value; }
    }
	#endregion
	
		#region Get Many To Many Relationship Functions
		#endregion
	
		#region Delete Functions
		/// <summary>
		/// 	Deletes a row from the DataSource.
		/// </summary>
		/// <param name="_objectAclid">. Primary Key.</param>	
		/// <param name="transactionManager"><see cref="TransactionManager"/> object</param>
		/// <remarks>Deletes based on primary key(s).</remarks>
		/// <returns>Returns true if operation suceeded.</returns>
        /// <exception cref="System.Exception">The command could not be executed.</exception>
        /// <exception cref="System.Data.DataException">The <paramref name="transactionManager"/> is not open.</exception>
        /// <exception cref="System.Data.Common.DbException">The command could not be executed.</exception>
		public override bool Delete(TransactionManager transactionManager, System.Int32 _objectAclid)
		{
			SqlDatabase database = new SqlDatabase(this._connectionString);
			DbCommand commandWrapper = StoredProcedureProvider.GetCommandWrapper(database, "dbo.uspObjectACL_Delete", _useStoredProcedure);
			database.AddInParameter(commandWrapper, "@ObjectAclid", DbType.Int32, _objectAclid);
			
			//Provider Data Requesting Command Event
			OnDataRequesting(new CommandEventArgs(commandWrapper, "Delete")); 

			int results = 0;
			
			if (transactionManager != null)
			{	
				results = Utility.ExecuteNonQuery(transactionManager, commandWrapper);
			}
			else
			{
				results = Utility.ExecuteNonQuery(database,commandWrapper);
			}
			
			//Stop Tracking Now that it has been updated and persisted.
			if (DataRepository.Provider.EnableEntityTracking)
			{
				string entityKey = EntityLocator.ConstructKeyFromPkItems(typeof(ObjectAcl)
					,_objectAclid);
				EntityManager.StopTracking(entityKey);
			}
			
			//Provider Data Requested Command Event
			OnDataRequested(new CommandEventArgs(commandWrapper, "Delete")); 

			commandWrapper = null;
			
			return Convert.ToBoolean(results);
		}//end Delete
		#endregion

		#region Find Functions

		#region Parsed Find Methods
		/// <summary>
		/// 	Returns rows meeting the whereClause condition from the DataSource.
		/// </summary>
		/// <param name="transactionManager"><see cref="TransactionManager"/> object</param>
		/// <param name="whereClause">Specifies the condition for the rows returned by a query (Name='John Doe', Name='John Doe' AND Id='1', Name='John Doe' OR Id='1').</param>
		/// <param name="start">Row number at which to start reading.</param>
		/// <param name="pageLength">Number of rows to return.</param>
		/// <param name="count">out. The number of rows that match this query.</param>
		/// <remarks>Operators must be capitalized (OR, AND).</remarks>
		/// <returns>Returns a typed collection of SecurityFoundation.Entities.ObjectAcl objects.</returns>
		public override TList<ObjectAcl> Find(TransactionManager transactionManager, string whereClause, int start, int pageLength, out int count)
		{
			count = -1;
			if (whereClause.IndexOf(";") > -1)
				return new TList<ObjectAcl>();
	
			SqlDatabase database = new SqlDatabase(this._connectionString);
			DbCommand commandWrapper = StoredProcedureProvider.GetCommandWrapper(database, "dbo.uspObjectACL_Find", _useStoredProcedure);

		bool searchUsingOR = false;
		if (whereClause.IndexOf(" OR ") > 0) // did they want to do "a=b OR c=d OR..."?
			searchUsingOR = true;
		
		database.AddInParameter(commandWrapper, "@SearchUsingOR", DbType.Boolean, searchUsingOR);
		
		database.AddInParameter(commandWrapper, "@ObjectAclid", DbType.Int32, DBNull.Value);
		database.AddInParameter(commandWrapper, "@ObjectId", DbType.Guid, DBNull.Value);
		database.AddInParameter(commandWrapper, "@RoleName", DbType.String, DBNull.Value);
		database.AddInParameter(commandWrapper, "@OwnAllowRead", DbType.Boolean, DBNull.Value);
		database.AddInParameter(commandWrapper, "@OwnAllowCreate", DbType.Boolean, DBNull.Value);
		database.AddInParameter(commandWrapper, "@OwnAllowUpdate", DbType.Boolean, DBNull.Value);
		database.AddInParameter(commandWrapper, "@OwnAllowDelete", DbType.Boolean, DBNull.Value);
		database.AddInParameter(commandWrapper, "@AllAllowRead", DbType.Boolean, DBNull.Value);
		database.AddInParameter(commandWrapper, "@AllAllowCreate", DbType.Boolean, DBNull.Value);
		database.AddInParameter(commandWrapper, "@AllAllowUpdate", DbType.Boolean, DBNull.Value);
		database.AddInParameter(commandWrapper, "@AllAllowDelete", DbType.Boolean, DBNull.Value);
		database.AddInParameter(commandWrapper, "@Added", DbType.DateTime, DBNull.Value);
	
			// replace all instances of 'AND' and 'OR' because we already set searchUsingOR
			whereClause = whereClause.Replace(" AND ", "|").Replace(" OR ", "|") ; 
			string[] clauses = whereClause.ToLower().Split('|');
		
			// Here's what's going on below: Find a field, then to get the value we
			// drop the field name from the front, trim spaces, drop the '=' sign,
			// trim more spaces, and drop any outer single quotes.
			// Now handles the case when two fields start off the same way - like "Friendly='Yes' AND Friend='john'"
				
			char[] equalSign = {'='};
			char[] singleQuote = {'\''};
	   		foreach (string clause in clauses)
			{
				if (clause.Trim().StartsWith("objectaclid ") || clause.Trim().StartsWith("objectaclid="))
				{
					database.SetParameterValue(commandWrapper, "@ObjectAclid", 
						clause.Trim().Remove(0,11).Trim().TrimStart(equalSign).Trim().Trim(singleQuote));
					continue;
				}
				if (clause.Trim().StartsWith("objectid ") || clause.Trim().StartsWith("objectid="))
				{
					database.SetParameterValue(commandWrapper, "@ObjectId", new Guid(
						clause.Trim().Remove(0,8).Trim().TrimStart(equalSign).Trim().Trim(singleQuote)));
					continue;
				}
				if (clause.Trim().StartsWith("rolename ") || clause.Trim().StartsWith("rolename="))
				{
					database.SetParameterValue(commandWrapper, "@RoleName", 
						clause.Trim().Remove(0,8).Trim().TrimStart(equalSign).Trim().Trim(singleQuote));
					continue;
				}
				if (clause.Trim().StartsWith("own_allowread ") || clause.Trim().StartsWith("own_allowread="))
				{
					database.SetParameterValue(commandWrapper, "@OwnAllowRead", 
						clause.Trim().Remove(0,13).Trim().TrimStart(equalSign).Trim().Trim(singleQuote));
					continue;
				}
				if (clause.Trim().StartsWith("own_allowcreate ") || clause.Trim().StartsWith("own_allowcreate="))
				{
					database.SetParameterValue(commandWrapper, "@OwnAllowCreate", 
						clause.Trim().Remove(0,15).Trim().TrimStart(equalSign).Trim().Trim(singleQuote));
					continue;
				}
				if (clause.Trim().StartsWith("own_allowupdate ") || clause.Trim().StartsWith("own_allowupdate="))
				{
					database.SetParameterValue(commandWrapper, "@OwnAllowUpdate", 
						clause.Trim().Remove(0,15).Trim().TrimStart(equalSign).Trim().Trim(singleQuote));
					continue;
				}
				if (clause.Trim().StartsWith("own_allowdelete ") || clause.Trim().StartsWith("own_allowdelete="))
				{
					database.SetParameterValue(commandWrapper, "@OwnAllowDelete", 
						clause.Trim().Remove(0,15).Trim().TrimStart(equalSign).Trim().Trim(singleQuote));
					continue;
				}
				if (clause.Trim().StartsWith("all_allowread ") || clause.Trim().StartsWith("all_allowread="))
				{
					database.SetParameterValue(commandWrapper, "@AllAllowRead", 
						clause.Trim().Remove(0,13).Trim().TrimStart(equalSign).Trim().Trim(singleQuote));
					continue;
				}
				if (clause.Trim().StartsWith("all_allowcreate ") || clause.Trim().StartsWith("all_allowcreate="))
				{
					database.SetParameterValue(commandWrapper, "@AllAllowCreate", 
						clause.Trim().Remove(0,15).Trim().TrimStart(equalSign).Trim().Trim(singleQuote));
					continue;
				}
				if (clause.Trim().StartsWith("all_allowupdate ") || clause.Trim().StartsWith("all_allowupdate="))
				{
					database.SetParameterValue(commandWrapper, "@AllAllowUpdate", 
						clause.Trim().Remove(0,15).Trim().TrimStart(equalSign).Trim().Trim(singleQuote));
					continue;
				}
				if (clause.Trim().StartsWith("all_allowdelete ") || clause.Trim().StartsWith("all_allowdelete="))
				{
					database.SetParameterValue(commandWrapper, "@AllAllowDelete", 
						clause.Trim().Remove(0,15).Trim().TrimStart(equalSign).Trim().Trim(singleQuote));
					continue;
				}
				if (clause.Trim().StartsWith("added ") || clause.Trim().StartsWith("added="))
				{
					database.SetParameterValue(commandWrapper, "@Added", 
						clause.Trim().Remove(0,5).Trim().TrimStart(equalSign).Trim().Trim(singleQuote));
					continue;
				}
	
				throw new ArgumentException("Unable to use this part of the where clause in this version of Find: " + clause);
			}
					
			IDataReader reader = null;
			//Create Collection
			TList<ObjectAcl> rows = new TList<ObjectAcl>();
	
				
			try
			{
				//Provider Data Requesting Command Event
				OnDataRequesting(new CommandEventArgs(commandWrapper, "Find", rows)); 

				if (transactionManager != null)
				{
					reader = Utility.ExecuteReader(transactionManager, commandWrapper);
				}
				else
				{
					reader = Utility.ExecuteReader(database, commandWrapper);
				}		
				
				Fill(reader, rows, start, pageLength);
				
				if(reader.NextResult())
				{
					if(reader.Read())
					{
						count = reader.GetInt32(0);
					}
				}
				
				//Provider Data Requested Command Event
				OnDataRequested(new CommandEventArgs(commandWrapper, "Find", rows)); 
			}
			finally
			{
				if (reader != null) 
					reader.Close();	
					
				commandWrapper = null;
			}
			return rows;
		}

		#endregion Parsed Find Methods
		
		#region Parameterized Find Methods
		
		/// <summary>
		/// 	Returns rows from the DataSource that meet the parameter conditions.
		/// </summary>
		/// <param name="transactionManager"><see cref="TransactionManager"/> object</param>
		/// <param name="parameters">A collection of <see cref="SqlFilterParameter"/> objects.</param>
		/// <param name="orderBy">Specifies the sort criteria for the rows in the DataSource (Name ASC; BirthDay DESC, Name ASC);</param>
		/// <param name="start">Row number at which to start reading.</param>
		/// <param name="pageLength">Number of rows to return.</param>
		/// <param name="count">out. The number of rows that match this query.</param>
		/// <returns>Returns a typed collection of SecurityFoundation.Entities.ObjectAcl objects.</returns>
		public override TList<ObjectAcl> Find(TransactionManager transactionManager, IFilterParameterCollection parameters, string orderBy, int start, int pageLength, out int count)
		{
			SqlFilterParameterCollection filter = null;
			
			if (parameters == null)
				filter = new SqlFilterParameterCollection();
			else 
				filter = parameters.GetParameters();
				
			SqlDatabase database = new SqlDatabase(this._connectionString);
			DbCommand commandWrapper = StoredProcedureProvider.GetCommandWrapper(database, "dbo.uspObjectACL_Find_Dynamic", typeof(ObjectAclColumn), filter, orderBy, start, pageLength);
		
			SqlFilterParameter param;

			for ( int i = 0; i < filter.Count; i++ )
			{
				param = filter[i];
				database.AddInParameter(commandWrapper, param.Name, param.DbType, param.GetValue());
			}

			TList<ObjectAcl> rows = new TList<ObjectAcl>();
			IDataReader reader = null;
			
			try
			{
				//Provider Data Requesting Command Event
				OnDataRequesting(new CommandEventArgs(commandWrapper, "Find", rows)); 

				if ( transactionManager != null )
				{
					reader = Utility.ExecuteReader(transactionManager, commandWrapper);
				}
				else
				{
					reader = Utility.ExecuteReader(database, commandWrapper);
				}
				
				Fill(reader, rows, 0, int.MaxValue);
				count = rows.Count;
				
				if ( reader.NextResult() )
				{
					if ( reader.Read() )
					{
						count = reader.GetInt32(0);
					}
				}
				
				//Provider Data Requested Command Event
				OnDataRequested(new CommandEventArgs(commandWrapper, "Find", rows)); 
			}
			finally
			{
				if ( reader != null )
					reader.Close();
					
				commandWrapper = null;
			}
			
			return rows;
		}
		
		#endregion Parameterized Find Methods
		
		#endregion Find Functions
	
		#region GetAll Methods
				
		/// <summary>
		/// 	Gets All rows from the DataSource.
		/// </summary>
		/// <param name="transactionManager"><see cref="TransactionManager"/> object</param>
		/// <param name="start">Row number at which to start reading.</param>
		/// <param name="pageLength">Number of rows to return.</param>
		/// <param name="count">out. The number of rows that match this query.</param>
		/// <remarks></remarks>
		/// <returns>Returns a typed collection of SecurityFoundation.Entities.ObjectAcl objects.</returns>
        /// <exception cref="System.Exception">The command could not be executed.</exception>
        /// <exception cref="System.Data.DataException">The <paramref name="transactionManager"/> is not open.</exception>
        /// <exception cref="System.Data.Common.DbException">The command could not be executed.</exception>
		public override TList<ObjectAcl> GetAll(TransactionManager transactionManager, int start, int pageLength, out int count)
		{
			SqlDatabase database = new SqlDatabase(this._connectionString);
			DbCommand commandWrapper = StoredProcedureProvider.GetCommandWrapper(database, "dbo.uspObjectACL_Get_List", _useStoredProcedure);
			
			IDataReader reader = null;
		
			//Create Collection
			TList<ObjectAcl> rows = new TList<ObjectAcl>();
			
			try
			{
				//Provider Data Requesting Command Event
				OnDataRequesting(new CommandEventArgs(commandWrapper, "GetAll", rows)); 
					
				if (transactionManager != null)
				{
					reader = Utility.ExecuteReader(transactionManager, commandWrapper);
				}
				else
				{
					reader = Utility.ExecuteReader(database, commandWrapper);
				}		
		
				Fill(reader, rows, start, pageLength);
				count = -1;
				if(reader.NextResult())
				{
					if(reader.Read())
					{
						count = reader.GetInt32(0);
					}
				}
				
				//Provider Data Requested Command Event
				OnDataRequested(new CommandEventArgs(commandWrapper, "GetAll", rows)); 
			}
			finally 
			{
				if (reader != null) 
					reader.Close();
					
				commandWrapper = null;	
			}
			return rows;
		}//end getall
		
		#endregion
				
		#region GetPaged Methods
				
		/// <summary>
		/// Gets a page of rows from the DataSource.
		/// </summary>
		/// <param name="start">Row number at which to start reading.</param>
		/// <param name="pageLength">Number of rows to return.</param>
		/// <param name="count">Number of rows in the DataSource.</param>
		/// <param name="whereClause">Specifies the condition for the rows returned by a query (Name='John Doe', Name='John Doe' AND Id='1', Name='John Doe' OR Id='1').</param>
		/// <param name="orderBy">Specifies the sort criteria for the rows in the DataSource (Name ASC; BirthDay DESC, Name ASC);</param>
		/// <param name="transactionManager"><see cref="TransactionManager"/> object</param>
		/// <remarks></remarks>
		/// <returns>Returns a typed collection of SecurityFoundation.Entities.ObjectAcl objects.</returns>
		public override TList<ObjectAcl> GetPaged(TransactionManager transactionManager, string whereClause, string orderBy, int start, int pageLength, out int count)
		{
			SqlDatabase database = new SqlDatabase(this._connectionString);
			DbCommand commandWrapper = StoredProcedureProvider.GetCommandWrapper(database, "dbo.uspObjectACL_GetPaged", _useStoredProcedure);
		
			
            if (commandWrapper.CommandType == CommandType.Text
                && commandWrapper.CommandText != null)
            {
                commandWrapper.CommandText = commandWrapper.CommandText.Replace(SqlUtil.PAGE_INDEX, string.Concat(SqlUtil.PAGE_INDEX, Guid.NewGuid().ToString("N").Substring(0, 8)));
            }
			
			database.AddInParameter(commandWrapper, "@WhereClause", DbType.String, whereClause);
			database.AddInParameter(commandWrapper, "@OrderBy", DbType.String, orderBy);
			database.AddInParameter(commandWrapper, "@PageIndex", DbType.Int32, start);
			database.AddInParameter(commandWrapper, "@PageSize", DbType.Int32, pageLength);
		
			IDataReader reader = null;
			//Create Collection
			TList<ObjectAcl> rows = new TList<ObjectAcl>();
			
			try
			{
				//Provider Data Requesting Command Event
				OnDataRequesting(new CommandEventArgs(commandWrapper, "GetPaged", rows)); 

				if (transactionManager != null)
				{
					reader = Utility.ExecuteReader(transactionManager, commandWrapper);
				}
				else
				{
					reader = Utility.ExecuteReader(database, commandWrapper);
				}
				
				Fill(reader, rows, 0, int.MaxValue);
				count = rows.Count;

				if(reader.NextResult())
				{
					if(reader.Read())
					{
						count = reader.GetInt32(0);
					}
				}
				
				//Provider Data Requested Command Event
				OnDataRequested(new CommandEventArgs(commandWrapper, "GetPaged", rows)); 

			}
			catch(Exception)
			{			
				throw;
			}
			finally
			{
				if (reader != null) 
					reader.Close();
				
				commandWrapper = null;
			}
			
			return rows;
		}
		
		#endregion	
		
		#region Get By Foreign Key Functions

		#region GetByObjectId
		/// <summary>
		/// 	Gets rows from the datasource based on the FK_ObjectACL_ObjectDefinition key.
		///		FK_ObjectACL_ObjectDefinition Description: 
		/// </summary>
		/// <param name="start">Row number at which to start reading.</param>
		/// <param name="pageLength">Number of rows to return.</param>
		/// <param name="transactionManager"><see cref="TransactionManager"/> object</param>
		/// <param name="_objectId"></param>
		/// <param name="count">out parameter to get total records for query</param>
		/// <remarks></remarks>
		/// <returns>Returns a typed collection of SecurityFoundation.Entities.ObjectAcl objects.</returns>
        /// <exception cref="System.Exception">The command could not be executed.</exception>
        /// <exception cref="System.Data.DataException">The <paramref name="transactionManager"/> is not open.</exception>
        /// <exception cref="System.Data.Common.DbException">The command could not be executed.</exception>
		public override TList<ObjectAcl> GetByObjectId(TransactionManager transactionManager, System.Guid _objectId, int start, int pageLength, out int count)
		{
			SqlDatabase database = new SqlDatabase(this._connectionString);
			DbCommand commandWrapper = StoredProcedureProvider.GetCommandWrapper(database, "dbo.uspObjectACL_GetByObjectId", _useStoredProcedure);
			
				database.AddInParameter(commandWrapper, "@ObjectId", DbType.Guid, _objectId);
			
			IDataReader reader = null;
			TList<ObjectAcl> rows = new TList<ObjectAcl>();
			try
			{
				//Provider Data Requesting Command Event
				OnDataRequesting(new CommandEventArgs(commandWrapper, "GetByObjectId", rows)); 

				if (transactionManager != null)
				{
					reader = Utility.ExecuteReader(transactionManager, commandWrapper);
				}
				else
				{
					reader = Utility.ExecuteReader(database, commandWrapper);
				}
			
				//Create Collection
				Fill(reader, rows, start, pageLength);
				count = -1;
				if(reader.NextResult())
				{
					if(reader.Read())
					{
						count = reader.GetInt32(0);
					}
				}
				
				//Provider Data Requested Command Event
				OnDataRequested(new CommandEventArgs(commandWrapper, "GetByObjectId", rows)); 
			}
			finally
			{
				if (reader != null) 
					reader.Close();
					
				commandWrapper = null;
			}
			return rows;
		}	
		#endregion
	
	#endregion
	
		#region Get By Index Functions

		#region GetByObjectAclid
					
		/// <summary>
		/// 	Gets rows from the datasource based on the PK_ObjectACL index.
		/// </summary>
		/// <param name="transactionManager"><see cref="TransactionManager"/> object</param>
		/// <param name="_objectAclid"></param>
		/// <param name="start">Row number at which to start reading.</param>
		/// <param name="pageLength">Number of rows to return.</param>
		/// <param name="count">out parameter to get total records for query.</param>
		/// <returns>Returns an instance of the <see cref="SecurityFoundation.Entities.ObjectAcl"/> class.</returns>
		/// <remarks></remarks>
        /// <exception cref="System.Exception">The command could not be executed.</exception>
        /// <exception cref="System.Data.DataException">The <paramref name="transactionManager"/> is not open.</exception>
        /// <exception cref="System.Data.Common.DbException">The command could not be executed.</exception>
		public override SecurityFoundation.Entities.ObjectAcl GetByObjectAclid(TransactionManager transactionManager, System.Int32 _objectAclid, int start, int pageLength, out int count)
		{
			SqlDatabase database = new SqlDatabase(this._connectionString);
			DbCommand commandWrapper = StoredProcedureProvider.GetCommandWrapper(database, "dbo.uspObjectACL_GetByObjectAclid", _useStoredProcedure);
			
				database.AddInParameter(commandWrapper, "@ObjectAclid", DbType.Int32, _objectAclid);
			
			IDataReader reader = null;
			TList<ObjectAcl> tmp = new TList<ObjectAcl>();
			try
			{
				//Provider Data Requesting Command Event
				OnDataRequesting(new CommandEventArgs(commandWrapper, "GetByObjectAclid", tmp)); 

				if (transactionManager != null)
				{
					reader = Utility.ExecuteReader(transactionManager, commandWrapper);
				}
				else
				{
					reader = Utility.ExecuteReader(database, commandWrapper);
				}		
		
				//Create collection and fill
				Fill(reader, tmp, start, pageLength);
				count = -1;
				if(reader.NextResult())
				{
					if(reader.Read())
					{
						count = reader.GetInt32(0);
					}
				}
				
				//Provider Data Requested Command Event
				OnDataRequested(new CommandEventArgs(commandWrapper, "GetByObjectAclid", tmp));
			}
			finally 
			{
				if (reader != null) 
					reader.Close();
					
				commandWrapper = null;
			}
			
			if (tmp.Count == 1)
			{
				return tmp[0];
			}
			else if (tmp.Count == 0)
			{
				return null;
			}
			else
			{
				throw new DataException("Cannot find the unique instance of the class.");
			}
			
			//return rows;
		}
		
		#endregion

	#endregion Get By Index Functions

		#region Insert Methods
		/// <summary>
		/// Lets you efficiently bulk insert many entities to the database.
		/// </summary>
		/// <param name="transactionManager">The transaction manager.</param>
		/// <param name="entities">The entities.</param>
		/// <remarks>
		///		After inserting into the datasource, the SecurityFoundation.Entities.ObjectAcl object will be updated
		/// 	to refelect any changes made by the datasource. (ie: identity or computed columns)
		/// </remarks>	
		public override void BulkInsert(TransactionManager transactionManager, TList<SecurityFoundation.Entities.ObjectAcl> entities)
		{
			//System.Data.SqlClient.SqlBulkCopy bulkCopy = new System.Data.SqlClient.SqlBulkCopy(this._connectionString, System.Data.SqlClient.SqlBulkCopyOptions.CheckConstraints); //, null);
			
			System.Data.SqlClient.SqlBulkCopy bulkCopy = null;
	
			if (transactionManager != null && transactionManager.IsOpen)
			{			
				System.Data.SqlClient.SqlConnection cnx = transactionManager.TransactionObject.Connection as System.Data.SqlClient.SqlConnection;
				System.Data.SqlClient.SqlTransaction transaction = transactionManager.TransactionObject as System.Data.SqlClient.SqlTransaction;
				bulkCopy = new System.Data.SqlClient.SqlBulkCopy(cnx, System.Data.SqlClient.SqlBulkCopyOptions.CheckConstraints, transaction); //, null);
			}
			else
			{
				bulkCopy = new System.Data.SqlClient.SqlBulkCopy(this._connectionString, System.Data.SqlClient.SqlBulkCopyOptions.CheckConstraints); //, null);
			}
			
			bulkCopy.BulkCopyTimeout = 360;
			bulkCopy.DestinationTableName = "ObjectACL";
			
			DataTable dataTable = new DataTable();
			DataColumn col0 = dataTable.Columns.Add("ObjectACLID", typeof(System.Int32));
			col0.AllowDBNull = false;		
			DataColumn col1 = dataTable.Columns.Add("ObjectID", typeof(System.Guid));
			col1.AllowDBNull = false;		
			DataColumn col2 = dataTable.Columns.Add("RoleName", typeof(System.String));
			col2.AllowDBNull = false;		
			DataColumn col3 = dataTable.Columns.Add("Own_AllowRead", typeof(System.Boolean));
			col3.AllowDBNull = false;		
			DataColumn col4 = dataTable.Columns.Add("Own_AllowCreate", typeof(System.Boolean));
			col4.AllowDBNull = false;		
			DataColumn col5 = dataTable.Columns.Add("Own_AllowUpdate", typeof(System.Boolean));
			col5.AllowDBNull = false;		
			DataColumn col6 = dataTable.Columns.Add("Own_AllowDelete", typeof(System.Boolean));
			col6.AllowDBNull = false;		
			DataColumn col7 = dataTable.Columns.Add("All_AllowRead", typeof(System.Boolean));
			col7.AllowDBNull = false;		
			DataColumn col8 = dataTable.Columns.Add("All_AllowCreate", typeof(System.Boolean));
			col8.AllowDBNull = false;		
			DataColumn col9 = dataTable.Columns.Add("All_AllowUpdate", typeof(System.Boolean));
			col9.AllowDBNull = false;		
			DataColumn col10 = dataTable.Columns.Add("All_AllowDelete", typeof(System.Boolean));
			col10.AllowDBNull = false;		
			DataColumn col11 = dataTable.Columns.Add("Added", typeof(System.DateTime));
			col11.AllowDBNull = false;		
			
			bulkCopy.ColumnMappings.Add("ObjectACLID", "ObjectACLID");
			bulkCopy.ColumnMappings.Add("ObjectID", "ObjectID");
			bulkCopy.ColumnMappings.Add("RoleName", "RoleName");
			bulkCopy.ColumnMappings.Add("Own_AllowRead", "Own_AllowRead");
			bulkCopy.ColumnMappings.Add("Own_AllowCreate", "Own_AllowCreate");
			bulkCopy.ColumnMappings.Add("Own_AllowUpdate", "Own_AllowUpdate");
			bulkCopy.ColumnMappings.Add("Own_AllowDelete", "Own_AllowDelete");
			bulkCopy.ColumnMappings.Add("All_AllowRead", "All_AllowRead");
			bulkCopy.ColumnMappings.Add("All_AllowCreate", "All_AllowCreate");
			bulkCopy.ColumnMappings.Add("All_AllowUpdate", "All_AllowUpdate");
			bulkCopy.ColumnMappings.Add("All_AllowDelete", "All_AllowDelete");
			bulkCopy.ColumnMappings.Add("Added", "Added");
			
			foreach(SecurityFoundation.Entities.ObjectAcl entity in entities)
			{
				if (entity.EntityState != EntityState.Added)
					continue;
					
				DataRow row = dataTable.NewRow();
				
					row["ObjectACLID"] = entity.ObjectAclid;
							
				
					row["ObjectID"] = entity.ObjectId;
							
				
					row["RoleName"] = entity.RoleName;
							
				
					row["Own_AllowRead"] = entity.OwnAllowRead;
							
				
					row["Own_AllowCreate"] = entity.OwnAllowCreate;
							
				
					row["Own_AllowUpdate"] = entity.OwnAllowUpdate;
							
				
					row["Own_AllowDelete"] = entity.OwnAllowDelete;
							
				
					row["All_AllowRead"] = entity.AllAllowRead;
							
				
					row["All_AllowCreate"] = entity.AllAllowCreate;
							
				
					row["All_AllowUpdate"] = entity.AllAllowUpdate;
							
				
					row["All_AllowDelete"] = entity.AllAllowDelete;
							
				
					row["Added"] = entity.Added;
							
				
				dataTable.Rows.Add(row);
			}		
			
			// send the data to the server		
			bulkCopy.WriteToServer(dataTable);		
			
			// update back the state
			foreach(SecurityFoundation.Entities.ObjectAcl entity in entities)
			{
				if (entity.EntityState != EntityState.Added)
					continue;
			
				entity.AcceptChanges();
			}
		}
				
		/// <summary>
		/// 	Inserts a SecurityFoundation.Entities.ObjectAcl object into the datasource using a transaction.
		/// </summary>
		/// <param name="transactionManager"><see cref="TransactionManager"/> object</param>
		/// <param name="entity">SecurityFoundation.Entities.ObjectAcl object to insert.</param>
		/// <remarks>
		///		After inserting into the datasource, the SecurityFoundation.Entities.ObjectAcl object will be updated
		/// 	to refelect any changes made by the datasource. (ie: identity or computed columns)
		/// </remarks>	
		/// <returns>Returns true if operation is successful.</returns>
        /// <exception cref="System.Exception">The command could not be executed.</exception>
        /// <exception cref="System.Data.DataException">The <paramref name="transactionManager"/> is not open.</exception>
        /// <exception cref="System.Data.Common.DbException">The command could not be executed.</exception>
		public override bool Insert(TransactionManager transactionManager, SecurityFoundation.Entities.ObjectAcl entity)
		{
			SqlDatabase database = new SqlDatabase(this._connectionString);
			DbCommand commandWrapper = StoredProcedureProvider.GetCommandWrapper(database, "dbo.uspObjectACL_Insert", _useStoredProcedure);
			
			database.AddOutParameter(commandWrapper, "@ObjectAclid", DbType.Int32, 4);
			database.AddInParameter(commandWrapper, "@ObjectId", DbType.Guid, entity.ObjectId );
			database.AddInParameter(commandWrapper, "@RoleName", DbType.String, entity.RoleName );
			database.AddInParameter(commandWrapper, "@OwnAllowRead", DbType.Boolean, entity.OwnAllowRead );
			database.AddInParameter(commandWrapper, "@OwnAllowCreate", DbType.Boolean, entity.OwnAllowCreate );
			database.AddInParameter(commandWrapper, "@OwnAllowUpdate", DbType.Boolean, entity.OwnAllowUpdate );
			database.AddInParameter(commandWrapper, "@OwnAllowDelete", DbType.Boolean, entity.OwnAllowDelete );
			database.AddInParameter(commandWrapper, "@AllAllowRead", DbType.Boolean, entity.AllAllowRead );
			database.AddInParameter(commandWrapper, "@AllAllowCreate", DbType.Boolean, entity.AllAllowCreate );
			database.AddInParameter(commandWrapper, "@AllAllowUpdate", DbType.Boolean, entity.AllAllowUpdate );
			database.AddInParameter(commandWrapper, "@AllAllowDelete", DbType.Boolean, entity.AllAllowDelete );
			database.AddInParameter(commandWrapper, "@Added", DbType.DateTime, entity.Added );
			
			int results = 0;
			
			//Provider Data Requesting Command Event
			OnDataRequesting(new CommandEventArgs(commandWrapper, "Insert", entity));
				
			if (transactionManager != null)
			{
				results = Utility.ExecuteNonQuery(transactionManager, commandWrapper);
			}
			else
			{
				results = Utility.ExecuteNonQuery(database,commandWrapper);
			}
					
			object _objectAclid = database.GetParameterValue(commandWrapper, "@ObjectAclid");
			entity.ObjectAclid = (System.Int32)_objectAclid;
			
			
			entity.AcceptChanges();
	
			//Provider Data Requested Command Event
			OnDataRequested(new CommandEventArgs(commandWrapper, "Insert", entity));

			return Convert.ToBoolean(results);
		}	
		#endregion

		#region Update Methods
				
		/// <summary>
		/// 	Update an existing row in the datasource.
		/// </summary>
		/// <param name="transactionManager"><see cref="TransactionManager"/> object</param>
		/// <param name="entity">SecurityFoundation.Entities.ObjectAcl object to update.</param>
		/// <remarks>
		///		After updating the datasource, the SecurityFoundation.Entities.ObjectAcl object will be updated
		/// 	to refelect any changes made by the datasource. (ie: identity or computed columns)
		/// </remarks>
		/// <returns>Returns true if operation is successful.</returns>
        /// <exception cref="System.Exception">The command could not be executed.</exception>
        /// <exception cref="System.Data.DataException">The <paramref name="transactionManager"/> is not open.</exception>
        /// <exception cref="System.Data.Common.DbException">The command could not be executed.</exception>
		public override bool Update(TransactionManager transactionManager, SecurityFoundation.Entities.ObjectAcl entity)
		{
			SqlDatabase database = new SqlDatabase(this._connectionString);
			DbCommand commandWrapper = StoredProcedureProvider.GetCommandWrapper(database, "dbo.uspObjectACL_Update", _useStoredProcedure);
			
			database.AddInParameter(commandWrapper, "@ObjectAclid", DbType.Int32, entity.ObjectAclid );
			database.AddInParameter(commandWrapper, "@ObjectId", DbType.Guid, entity.ObjectId );
			database.AddInParameter(commandWrapper, "@RoleName", DbType.String, entity.RoleName );
			database.AddInParameter(commandWrapper, "@OwnAllowRead", DbType.Boolean, entity.OwnAllowRead );
			database.AddInParameter(commandWrapper, "@OwnAllowCreate", DbType.Boolean, entity.OwnAllowCreate );
			database.AddInParameter(commandWrapper, "@OwnAllowUpdate", DbType.Boolean, entity.OwnAllowUpdate );
			database.AddInParameter(commandWrapper, "@OwnAllowDelete", DbType.Boolean, entity.OwnAllowDelete );
			database.AddInParameter(commandWrapper, "@AllAllowRead", DbType.Boolean, entity.AllAllowRead );
			database.AddInParameter(commandWrapper, "@AllAllowCreate", DbType.Boolean, entity.AllAllowCreate );
			database.AddInParameter(commandWrapper, "@AllAllowUpdate", DbType.Boolean, entity.AllAllowUpdate );
			database.AddInParameter(commandWrapper, "@AllAllowDelete", DbType.Boolean, entity.AllAllowDelete );
			database.AddInParameter(commandWrapper, "@Added", DbType.DateTime, entity.Added );
			
			int results = 0;
			
			//Provider Data Requesting Command Event
			OnDataRequesting(new CommandEventArgs(commandWrapper, "Update", entity));

			if (transactionManager != null)
			{
				results = Utility.ExecuteNonQuery(transactionManager, commandWrapper);
			}
			else
			{
				results = Utility.ExecuteNonQuery(database,commandWrapper);
			}
			
			//Stop Tracking Now that it has been updated and persisted.
			if (DataRepository.Provider.EnableEntityTracking)
				EntityManager.StopTracking(entity.EntityTrackingKey);
			
			
			entity.AcceptChanges();
			
			//Provider Data Requested Command Event
			OnDataRequested(new CommandEventArgs(commandWrapper, "Update", entity));

			return Convert.ToBoolean(results);
		}
			
		#endregion
		
		#region Custom Methods
	
		#endregion
	}//end class
} // end namespace
