﻿using System;
using System.ComponentModel;

namespace SecurityFoundation.Entities
{
	/// <summary>
	///		The data structure representation of the 'ApplicationDefination' table via interface.
	/// </summary>
	/// <remarks>
	/// 	This struct is generated by a tool and should never be modified.
	/// </remarks>
	public interface IApplicationDefination 
	{
		/// <summary>			
		/// ApplicationKey : 
		/// </summary>
		/// <remarks>Member of the primary key of the underlying table "ApplicationDefination"</remarks>
		System.Guid ApplicationKey { get; set; }
				
		/// <summary>
		/// keep a copy of the original so it can be used for editable primary keys.
		/// </summary>
		System.Guid OriginalApplicationKey { get; set; }
			
		
		
		/// <summary>
		/// ApplicationName : 
		/// </summary>
		System.String  ApplicationName  { get; set; }
		
		/// <summary>
		/// Realm : 
		/// </summary>
		System.Guid  Realm  { get; set; }
		
		/// <summary>
		/// ObjectSecurity : 0 for not required, 1 for optional, 2 for required
		/// </summary>
		System.Int32  ObjectSecurity  { get; set; }
		
		/// <summary>
		/// FieldLevelSecurity : 
		/// </summary>
		System.Int32  FieldLevelSecurity  { get; set; }
		
		/// <summary>
		/// OwnerRole : 
		/// </summary>
		System.String  OwnerRole  { get; set; }
		
		/// <summary>
		/// ApplicationType : 0 for client, 1 for service
		/// </summary>
		System.Int32  ApplicationType  { get; set; }
		
		/// <summary>
		/// UseRealmRole : 0 as Allways, 1 as optional, 2 as not allowed ie all roles must be defined in mapping table
		/// </summary>
		System.Int32  UseRealmRole  { get; set; }
			
		/// <summary>
		/// Creates a new object that is a copy of the current instance.
		/// </summary>
		/// <returns>A new object that is a copy of this instance.</returns>
		System.Object Clone();
		
		#region Data Properties


		/// <summary>
		///	Holds a collection of entity objects
		///	which are related to this object through the relation _applicationRoleMappingApplicationKey
		/// </summary>	
		TList<ApplicationRoleMapping> ApplicationRoleMappingCollection {  get;  set;}	


		/// <summary>
		///	Holds a collection of entity objects
		///	which are related to this object through the relation _userProfileDataApplicationKey
		/// </summary>	
		TList<UserProfileData> UserProfileDataCollection {  get;  set;}	


		/// <summary>
		///	Holds a collection of entity objects
		///	which are related to this object through the relation _objectDefinitionApplicationKey
		/// </summary>	
		TList<ObjectDefinition> ObjectDefinitionCollection {  get;  set;}	


		/// <summary>
		///	Holds a collection of entity objects
		///	which are related to this object through the relation _securityTokenSourceApplication
		/// </summary>	
		TList<SecurityToken> SecurityTokenCollection {  get;  set;}	

		#endregion Data Properties

	}
}


