﻿
/*
	File generated by NetTiers templates [www.nettiers.com]
	Important: Do not modify this file. Edit the file Realm.cs instead.
*/

#region using directives
using System;
using System.ComponentModel;
using System.Collections;
using System.Xml.Serialization;
using System.Runtime.Serialization;

using SecurityFoundation.Entities.Validation;
#endregion

namespace SecurityFoundation.Entities
{
	///<summary>
	/// An object representation of the 'Realm' table. [No description found the database]	
	///</summary>
	[Serializable]
	[DataObject, CLSCompliant(true)]
	public abstract partial class RealmBase : EntityBase, IRealm, IEntityId<RealmKey>, System.IComparable, System.ICloneable, ICloneableEx, IEditableObject, IComponent, INotifyPropertyChanged
	{		
		#region Variable Declarations
		
		/// <summary>
		///  Hold the inner data of the entity.
		/// </summary>
		private RealmEntityData entityData;
		
		/// <summary>
		/// 	Hold the original data of the entity, as loaded from the repository.
		/// </summary>
		private RealmEntityData _originalData;
		
		/// <summary>
		/// 	Hold a backup of the inner data of the entity.
		/// </summary>
		private RealmEntityData backupData; 
		
		/// <summary>
		/// 	Key used if Tracking is Enabled for the <see cref="EntityLocator" />.
		/// </summary>
		private string entityTrackingKey;
		
		/// <summary>
		/// 	Hold the parent TList&lt;entity&gt; in which this entity maybe contained.
		/// </summary>
		/// <remark>Mostly used for databinding</remark>
		[NonSerialized]
		private TList<Realm> parentCollection;
		
		private bool inTxn = false;
		
		/// <summary>
		/// Occurs when a value is being changed for the specified column.
		/// </summary>
		[field:NonSerialized]
		public event RealmEventHandler ColumnChanging;		
		
		/// <summary>
		/// Occurs after a value has been changed for the specified column.
		/// </summary>
		[field:NonSerialized]
		public event RealmEventHandler ColumnChanged;
		
		#endregion Variable Declarations
		
		#region Constructors
		///<summary>
		/// Creates a new <see cref="RealmBase"/> instance.
		///</summary>
		public RealmBase()
		{
			this.entityData = new RealmEntityData();
			this.backupData = null;
		}		
		
		///<summary>
		/// Creates a new <see cref="RealmBase"/> instance.
		///</summary>
		///<param name="_realmId"></param>
		///<param name="_realm"></param>
		///<param name="_authenticationProviderName"></param>
		///<param name="_roleProviderName"></param>
		///<param name="_tokenLife"></param>
		///<param name="_adminApplication"></param>
		public RealmBase(System.Guid _realmId, System.String _realm, System.String _authenticationProviderName, 
			System.String _roleProviderName, System.Int32 _tokenLife, System.Guid? _adminApplication)
		{
			this.entityData = new RealmEntityData();
			this.backupData = null;

			this.RealmId = _realmId;
			this.Realm = _realm;
			this.AuthenticationProviderName = _authenticationProviderName;
			this.RoleProviderName = _roleProviderName;
			this.TokenLife = _tokenLife;
			this.AdminApplication = _adminApplication;
		}
		
		///<summary>
		/// A simple factory method to create a new <see cref="Realm"/> instance.
		///</summary>
		///<param name="_realmId"></param>
		///<param name="_realm"></param>
		///<param name="_authenticationProviderName"></param>
		///<param name="_roleProviderName"></param>
		///<param name="_tokenLife"></param>
		///<param name="_adminApplication"></param>
		public static Realm CreateRealm(System.Guid _realmId, System.String _realm, System.String _authenticationProviderName, 
			System.String _roleProviderName, System.Int32 _tokenLife, System.Guid? _adminApplication)
		{
			Realm newRealm = new Realm();
			newRealm.RealmId = _realmId;
			newRealm.Realm = _realm;
			newRealm.AuthenticationProviderName = _authenticationProviderName;
			newRealm.RoleProviderName = _roleProviderName;
			newRealm.TokenLife = _tokenLife;
			newRealm.AdminApplication = _adminApplication;
			return newRealm;
		}
				
		#endregion Constructors
			
		#region Properties	
		
		#region Data Properties		
		/// <summary>
		/// 	Gets or sets the RealmId property. 
		///		
		/// </summary>
		/// <value>This type is uniqueidentifier.</value>
		/// <remarks>
		/// This property can not be set to null. 
		/// </remarks>




		[DescriptionAttribute(@""), System.ComponentModel.Bindable( System.ComponentModel.BindableSupport.Yes)]
		[DataObjectField(true, false, false)]
		public virtual System.Guid RealmId
		{
			get
			{
				return this.entityData.RealmId; 
			}
			
			set
			{
				if (this.entityData.RealmId == value)
					return;
				
                OnPropertyChanging("RealmId");                    
				OnColumnChanging(RealmColumn.RealmId, this.entityData.RealmId);
				this.entityData.RealmId = value;
				this.EntityId.RealmId = value;
				if (this.EntityState == EntityState.Unchanged)
					this.EntityState = EntityState.Changed;
				OnColumnChanged(RealmColumn.RealmId, this.entityData.RealmId);
				OnPropertyChanged("RealmId");
			}
		}
		
		/// <summary>
		/// 	Get the original value of the RealmID property.
		///		
		/// </summary>
		/// <remarks>This is the original value of the RealmID property.</remarks>
		/// <value>This type is uniqueidentifier</value>
		[BrowsableAttribute(false)/*, XmlIgnoreAttribute()*/]
		public  virtual System.Guid OriginalRealmId
		{
			get { return this.entityData.OriginalRealmId; }
			set { this.entityData.OriginalRealmId = value; }
		}
		
		/// <summary>
		/// 	Gets or sets the Realm property. 
		///		
		/// </summary>
		/// <value>This type is nvarchar.</value>
		/// <remarks>
		/// This property can not be set to null. 
		/// </remarks>
		/// <exception cref="ArgumentNullException">If you attempt to set to null.</exception>




		[DescriptionAttribute(@""), System.ComponentModel.Bindable( System.ComponentModel.BindableSupport.Yes)]
		[DataObjectField(false, false, false, 50)]
		public virtual System.String Realm
		{
			get
			{
				return this.entityData.Realm; 
			}
			
			set
			{
				if (this.entityData.Realm == value)
					return;
				
                OnPropertyChanging("Realm");                    
				OnColumnChanging(RealmColumn.Realm, this.entityData.Realm);
				this.entityData.Realm = value;
				if (this.EntityState == EntityState.Unchanged)
					this.EntityState = EntityState.Changed;
				OnColumnChanged(RealmColumn.Realm, this.entityData.Realm);
				OnPropertyChanged("Realm");
			}
		}
		
		/// <summary>
		/// 	Gets or sets the AuthenticationProviderName property. 
		///		
		/// </summary>
		/// <value>This type is nvarchar.</value>
		/// <remarks>
		/// This property can be set to null. 
		/// </remarks>




		[DescriptionAttribute(@""), System.ComponentModel.Bindable( System.ComponentModel.BindableSupport.Yes)]
		[DataObjectField(false, false, true, 50)]
		public virtual System.String AuthenticationProviderName
		{
			get
			{
				return this.entityData.AuthenticationProviderName; 
			}
			
			set
			{
				if (this.entityData.AuthenticationProviderName == value)
					return;
				
                OnPropertyChanging("AuthenticationProviderName");                    
				OnColumnChanging(RealmColumn.AuthenticationProviderName, this.entityData.AuthenticationProviderName);
				this.entityData.AuthenticationProviderName = value;
				if (this.EntityState == EntityState.Unchanged)
					this.EntityState = EntityState.Changed;
				OnColumnChanged(RealmColumn.AuthenticationProviderName, this.entityData.AuthenticationProviderName);
				OnPropertyChanged("AuthenticationProviderName");
			}
		}
		
		/// <summary>
		/// 	Gets or sets the RoleProviderName property. 
		///		
		/// </summary>
		/// <value>This type is nvarchar.</value>
		/// <remarks>
		/// This property can be set to null. 
		/// </remarks>




		[DescriptionAttribute(@""), System.ComponentModel.Bindable( System.ComponentModel.BindableSupport.Yes)]
		[DataObjectField(false, false, true, 50)]
		public virtual System.String RoleProviderName
		{
			get
			{
				return this.entityData.RoleProviderName; 
			}
			
			set
			{
				if (this.entityData.RoleProviderName == value)
					return;
				
                OnPropertyChanging("RoleProviderName");                    
				OnColumnChanging(RealmColumn.RoleProviderName, this.entityData.RoleProviderName);
				this.entityData.RoleProviderName = value;
				if (this.EntityState == EntityState.Unchanged)
					this.EntityState = EntityState.Changed;
				OnColumnChanged(RealmColumn.RoleProviderName, this.entityData.RoleProviderName);
				OnPropertyChanged("RoleProviderName");
			}
		}
		
		/// <summary>
		/// 	Gets or sets the TokenLife property. 
		///		
		/// </summary>
		/// <value>This type is int.</value>
		/// <remarks>
		/// This property can not be set to null. 
		/// </remarks>




		[DescriptionAttribute(@""), System.ComponentModel.Bindable( System.ComponentModel.BindableSupport.Yes)]
		[DataObjectField(false, false, false)]
		public virtual System.Int32 TokenLife
		{
			get
			{
				return this.entityData.TokenLife; 
			}
			
			set
			{
				if (this.entityData.TokenLife == value)
					return;
				
                OnPropertyChanging("TokenLife");                    
				OnColumnChanging(RealmColumn.TokenLife, this.entityData.TokenLife);
				this.entityData.TokenLife = value;
				if (this.EntityState == EntityState.Unchanged)
					this.EntityState = EntityState.Changed;
				OnColumnChanged(RealmColumn.TokenLife, this.entityData.TokenLife);
				OnPropertyChanged("TokenLife");
			}
		}
		
		/// <summary>
		/// 	Gets or sets the AdminApplication property. 
		///		
		/// </summary>
		/// <value>This type is uniqueidentifier.</value>
		/// <remarks>
		/// This property can be set to null. 
		/// If this column is null, this property will return Guid.Empty. It is up to the developer
		/// to check the value of IsAdminApplicationNull() and perform business logic appropriately.
		/// </remarks>




		[DescriptionAttribute(@""), System.ComponentModel.Bindable( System.ComponentModel.BindableSupport.Yes)]
		[DataObjectField(false, false, true)]
		public virtual System.Guid? AdminApplication
		{
			get
			{
				return this.entityData.AdminApplication; 
			}
			
			set
			{
				if (this.entityData.AdminApplication == value)
					return;
				
                OnPropertyChanging("AdminApplication");                    
				OnColumnChanging(RealmColumn.AdminApplication, this.entityData.AdminApplication);
				this.entityData.AdminApplication = value;
				if (this.EntityState == EntityState.Unchanged)
					this.EntityState = EntityState.Changed;
				OnColumnChanged(RealmColumn.AdminApplication, this.entityData.AdminApplication);
				OnPropertyChanged("AdminApplication");
			}
		}
		
		#endregion Data Properties		

		#region Source Foreign Key Property
				
		#endregion
		
		#region Children Collections
	
		/// <summary>
		///	Holds a collection of ApplicationDefination objects
		///	which are related to this object through the relation FK_ApplicationDefination_Realm
		/// </summary>	
		[System.ComponentModel.Bindable(System.ComponentModel.BindableSupport.Yes)]
		public virtual TList<ApplicationDefination> ApplicationDefinationCollection
		{
			get { return entityData.ApplicationDefinationCollection; }
			set { entityData.ApplicationDefinationCollection = value; }	
		}
	
		/// <summary>
		///	Holds a collection of SecurityToken objects
		///	which are related to this object through the relation FK_SecurityToken_Realm
		/// </summary>	
		[System.ComponentModel.Bindable(System.ComponentModel.BindableSupport.Yes)]
		public virtual TList<SecurityToken> SecurityTokenCollection
		{
			get { return entityData.SecurityTokenCollection; }
			set { entityData.SecurityTokenCollection = value; }	
		}
		#endregion Children Collections
		
		#endregion
		#region Validation
		
		/// <summary>
		/// Assigns validation rules to this object based on model definition.
		/// </summary>
		/// <remarks>This method overrides the base class to add schema related validation.</remarks>
		protected override void AddValidationRules()
		{
			//Validation rules based on database schema.
			ValidationRules.AddRule( CommonRules.NotNull,
				new ValidationRuleArgs("Realm", "Realm"));
			ValidationRules.AddRule( CommonRules.StringMaxLength, 
				new CommonRules.MaxLengthRuleArgs("Realm", "Realm", 50));
			ValidationRules.AddRule( CommonRules.StringMaxLength, 
				new CommonRules.MaxLengthRuleArgs("AuthenticationProviderName", "Authentication Provider Name", 50));
			ValidationRules.AddRule( CommonRules.StringMaxLength, 
				new CommonRules.MaxLengthRuleArgs("RoleProviderName", "Role Provider Name", 50));
		}
   		#endregion
		
		#region Table Meta Data
		/// <summary>
		///		The name of the underlying database table.
		/// </summary>
		[BrowsableAttribute(false), XmlIgnoreAttribute()]
		public override string TableName
		{
			get { return "Realm"; }
		}
		
		/// <summary>
		///		The name of the underlying database table's columns.
		/// </summary>
		[BrowsableAttribute(false), XmlIgnoreAttribute()]
		public override string[] TableColumns
		{
			get
			{
				return new string[] {"RealmID", "Realm", "AuthenticationProviderName", "RoleProviderName", "TokenLife", "AdminApplication"};
			}
		}
		#endregion 
		
		#region IEditableObject
		
		#region  CancelAddNew Event
		/// <summary>
        /// The delegate for the CancelAddNew event.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
		public delegate void CancelAddNewEventHandler(object sender, EventArgs e);
    
    	/// <summary>
		/// The CancelAddNew event.
		/// </summary>
		[field:NonSerialized]
		public event CancelAddNewEventHandler CancelAddNew ;

		/// <summary>
        /// Called when [cancel add new].
        /// </summary>
        public void OnCancelAddNew()
        {    
			if (!SuppressEntityEvents)
			{
	            CancelAddNewEventHandler handler = CancelAddNew ;
            	if (handler != null)
	            {    
    	            handler(this, EventArgs.Empty) ;
        	    }
	        }
        }
		#endregion 
		
		/// <summary>
		/// Begins an edit on an object.
		/// </summary>
		void IEditableObject.BeginEdit() 
	    {
	        //Console.WriteLine("Start BeginEdit");
	        if (!inTxn) 
	        {
	            this.backupData = this.entityData.Clone() as RealmEntityData;
	            inTxn = true;
	            //Console.WriteLine("BeginEdit");
	        }
	        //Console.WriteLine("End BeginEdit");
	    }
	
		/// <summary>
		/// Discards changes since the last <c>BeginEdit</c> call.
		/// </summary>
	    void IEditableObject.CancelEdit() 
	    {
	        //Console.WriteLine("Start CancelEdit");
	        if (this.inTxn) 
	        {
	            this.entityData = this.backupData;
	            this.backupData = null;
				this.inTxn = false;

				if (this.bindingIsNew)
	        	//if (this.EntityState == EntityState.Added)
	        	{
					if (this.parentCollection != null)
						this.parentCollection.Remove( (Realm) this ) ;
				}	            
	        }
	        //Console.WriteLine("End CancelEdit");
	    }
	
		/// <summary>
		/// Pushes changes since the last <c>BeginEdit</c> or <c>IBindingList.AddNew</c> call into the underlying object.
		/// </summary>
	    void IEditableObject.EndEdit() 
	    {
	        //Console.WriteLine("Start EndEdit" + this.custData.id + this.custData.lastName);
	        if (this.inTxn) 
	        {
	            this.backupData = null;
				if (this.IsDirty) 
				{
					if (this.bindingIsNew) {
						this.EntityState = EntityState.Added;
						this.bindingIsNew = false ;
					}
					else
						if (this.EntityState == EntityState.Unchanged) 
							this.EntityState = EntityState.Changed ;
				}

				this.bindingIsNew = false ;
	            this.inTxn = false;	            
	        }
	        //Console.WriteLine("End EndEdit");
	    }
	    
	    /// <summary>
        /// Gets or sets the parent collection of this current entity, if available.
        /// </summary>
        /// <value>The parent collection.</value>
	    [XmlIgnore]
		[Browsable(false)]
	    public override object ParentCollection
	    {
	        get 
	        {
	            return this.parentCollection;
	        }
	        set 
	        {
	            this.parentCollection = value as TList<Realm>;
	        }
	    }
	    
	    /// <summary>
        /// Called when the entity is changed.
        /// </summary>
	    private void OnEntityChanged() 
	    {
	        if (!SuppressEntityEvents && !inTxn && this.parentCollection != null) 
	        {
	            this.parentCollection.EntityChanged(this as Realm);
	        }
	    }


		#endregion
		
		#region ICloneable Members
		///<summary>
		///  Returns a Typed Realm Entity 
		///</summary>
		protected virtual Realm Copy(IDictionary existingCopies)
		{
			if (existingCopies == null)
			{
				// This is the root of the tree to be copied!
				existingCopies = new Hashtable();
			}

			//shallow copy entity
			Realm copy = new Realm();
			existingCopies.Add(this, copy);
			copy.SuppressEntityEvents = true;
				copy.RealmId = this.RealmId;
					copy.OriginalRealmId = this.OriginalRealmId;
				copy.Realm = this.Realm;
				copy.AuthenticationProviderName = this.AuthenticationProviderName;
				copy.RoleProviderName = this.RoleProviderName;
				copy.TokenLife = this.TokenLife;
				copy.AdminApplication = this.AdminApplication;
			
		
			//deep copy nested objects
			copy.ApplicationDefinationCollection = (TList<ApplicationDefination>) MakeCopyOf(this.ApplicationDefinationCollection, existingCopies); 
			copy.SecurityTokenCollection = (TList<SecurityToken>) MakeCopyOf(this.SecurityTokenCollection, existingCopies); 
			copy.EntityState = this.EntityState;
			copy.SuppressEntityEvents = false;
			return copy;
		}		
		
		
		
		///<summary>
		///  Returns a Typed Realm Entity 
		///</summary>
		public virtual Realm Copy()
		{
			return this.Copy(null);	
		}
		
		///<summary>
		/// ICloneable.Clone() Member, returns the Shallow Copy of this entity.
		///</summary>
		public object Clone()
		{
			return this.Copy(null);
		}
		
		///<summary>
		/// ICloneableEx.Clone() Member, returns the Shallow Copy of this entity.
		///</summary>
		public object Clone(IDictionary existingCopies)
		{
			return this.Copy(existingCopies);
		}
		
		///<summary>
		/// Returns a deep copy of the child collection object passed in.
		///</summary>
		public static object MakeCopyOf(object x)
		{
			if (x == null)
				return null;
				
			if (x is ICloneable)
			{
				// Return a deep copy of the object
				return ((ICloneable)x).Clone();
			}
			else
				throw new System.NotSupportedException("Object Does Not Implement the ICloneable Interface.");
		}
		
		///<summary>
		/// Returns a deep copy of the child collection object passed in.
		///</summary>
		public static object MakeCopyOf(object x, IDictionary existingCopies)
		{
			if (x == null)
				return null;
			
			if (x is ICloneableEx)
			{
				// Return a deep copy of the object
				return ((ICloneableEx)x).Clone(existingCopies);
			}
			else if (x is ICloneable)
			{
				// Return a deep copy of the object
				return ((ICloneable)x).Clone();
			}
			else
				throw new System.NotSupportedException("Object Does Not Implement the ICloneable or IClonableEx Interface.");
		}
		
		
		///<summary>
		///  Returns a Typed Realm Entity which is a deep copy of the current entity.
		///</summary>
		public virtual Realm DeepCopy()
		{
			return EntityHelper.Clone<Realm>(this as Realm);	
		}
		#endregion
		
		#region Methods	
			
		///<summary>
		/// Revert all changes and restore original values.
		///</summary>
		public override void CancelChanges()
		{
			IEditableObject obj = (IEditableObject) this;
			obj.CancelEdit();

			this.entityData = null;
			if (this._originalData != null)
			{
				this.entityData = this._originalData.Clone() as RealmEntityData;
			}
			else
			{
				//Since this had no _originalData, then just reset the entityData with a new one.  entityData cannot be null.
				this.entityData = new RealmEntityData();
			}
		}	
		
		/// <summary>
		/// Accepts the changes made to this object.
		/// </summary>
		/// <remarks>
		/// After calling this method, properties: IsDirty, IsNew are false. IsDeleted flag remains unchanged as it is handled by the parent List.
		/// </remarks>
		public override void AcceptChanges()
		{
			base.AcceptChanges();

			// we keep of the original version of the data
			this._originalData = null;
			this._originalData = this.entityData.Clone() as RealmEntityData;
		}
		
		#region Comparision with original data
		
		/// <summary>
		/// Determines whether the property value has changed from the original data.
		/// </summary>
		/// <param name="column">The column.</param>
		/// <returns>
		/// 	<c>true</c> if the property value has changed; otherwise, <c>false</c>.
		/// </returns>
		public bool IsPropertyChanged(RealmColumn column)
		{
			switch(column)
			{
					case RealmColumn.RealmId:
					return entityData.RealmId != _originalData.RealmId;
					case RealmColumn.Realm:
					return entityData.Realm != _originalData.Realm;
					case RealmColumn.AuthenticationProviderName:
					return entityData.AuthenticationProviderName != _originalData.AuthenticationProviderName;
					case RealmColumn.RoleProviderName:
					return entityData.RoleProviderName != _originalData.RoleProviderName;
					case RealmColumn.TokenLife:
					return entityData.TokenLife != _originalData.TokenLife;
					case RealmColumn.AdminApplication:
					return entityData.AdminApplication != _originalData.AdminApplication;
			
				default:
					return false;
			}
		}
		
		/// <summary>
		/// Determines whether the property value has changed from the original data.
		/// </summary>
		/// <param name="columnName">The column name.</param>
		/// <returns>
		/// 	<c>true</c> if the property value has changed; otherwise, <c>false</c>.
		/// </returns>
		public override bool IsPropertyChanged(string columnName)
		{
			return 	IsPropertyChanged(EntityHelper.GetEnumValue< RealmColumn >(columnName));
		}
		
		/// <summary>
		/// Determines whether the data has changed from original.
		/// </summary>
		/// <returns>
		/// 	<c>true</c> if data has changed; otherwise, <c>false</c>.
		/// </returns>
		public bool HasDataChanged()
		{
			bool result = false;
			result = result || entityData.RealmId != _originalData.RealmId;
			result = result || entityData.Realm != _originalData.Realm;
			result = result || entityData.AuthenticationProviderName != _originalData.AuthenticationProviderName;
			result = result || entityData.RoleProviderName != _originalData.RoleProviderName;
			result = result || entityData.TokenLife != _originalData.TokenLife;
			result = result || entityData.AdminApplication != _originalData.AdminApplication;
			return result;
		}	
		
		///<summary>
		///  Returns a Realm Entity with the original data.
		///</summary>
		public Realm GetOriginalEntity()
		{
			if (_originalData != null)
				return CreateRealm(
				_originalData.RealmId,
				_originalData.Realm,
				_originalData.AuthenticationProviderName,
				_originalData.RoleProviderName,
				_originalData.TokenLife,
				_originalData.AdminApplication
				);
				
			return (Realm)this.Clone();
		}
		#endregion
	
	#region Value Semantics Instance Equality
        ///<summary>
        /// Returns a value indicating whether this instance is equal to a specified object using value semantics.
        ///</summary>
        ///<param name="Object1">An object to compare to this instance.</param>
        ///<returns>true if Object1 is a <see cref="RealmBase"/> and has the same value as this instance; otherwise, false.</returns>
        public override bool Equals(object Object1)
        {
			// Cast exception if Object1 is null or DbNull
			if (Object1 != null && Object1 != DBNull.Value && Object1 is RealmBase)
				return ValueEquals(this, (RealmBase)Object1);
			else
				return false;
        }

        /// <summary>
		/// Serves as a hash function for a particular type, suitable for use in hashing algorithms and data structures like a hash table.
        /// Provides a hash function that is appropriate for <see cref="RealmBase"/> class 
        /// and that ensures a better distribution in the hash table
        /// </summary>
        /// <returns>number (hash code) that corresponds to the value of an object</returns>
        public override int GetHashCode()
        {
			return this.RealmId.GetHashCode() ^ 
					this.Realm.GetHashCode() ^ 
					((this.AuthenticationProviderName == null) ? string.Empty : this.AuthenticationProviderName.ToString()).GetHashCode() ^ 
					((this.RoleProviderName == null) ? string.Empty : this.RoleProviderName.ToString()).GetHashCode() ^ 
					this.TokenLife.GetHashCode() ^ 
					((this.AdminApplication == null) ? string.Empty : this.AdminApplication.ToString()).GetHashCode();
        }
		
		///<summary>
		/// Returns a value indicating whether this instance is equal to a specified object using value semantics.
		///</summary>
		///<param name="toObject">An object to compare to this instance.</param>
		///<returns>true if toObject is a <see cref="RealmBase"/> and has the same value as this instance; otherwise, false.</returns>
		public virtual bool Equals(RealmBase toObject)
		{
			if (toObject == null)
				return false;
			return ValueEquals(this, toObject);
		}
		#endregion
		
		///<summary>
		/// Determines whether the specified <see cref="RealmBase"/> instances are considered equal using value semantics.
		///</summary>
		///<param name="Object1">The first <see cref="RealmBase"/> to compare.</param>
		///<param name="Object2">The second <see cref="RealmBase"/> to compare. </param>
		///<returns>true if Object1 is the same instance as Object2 or if both are null references or if objA.Equals(objB) returns true; otherwise, false.</returns>
		public static bool ValueEquals(RealmBase Object1, RealmBase Object2)
		{
			// both are null
			if (Object1 == null && Object2 == null)
				return true;

			// one or the other is null, but not both
			if (Object1 == null ^ Object2 == null)
				return false;
				
			bool equal = true;
			if (Object1.RealmId != Object2.RealmId)
				equal = false;
			if (Object1.Realm != Object2.Realm)
				equal = false;
			if ( Object1.AuthenticationProviderName != null && Object2.AuthenticationProviderName != null )
			{
				if (Object1.AuthenticationProviderName != Object2.AuthenticationProviderName)
					equal = false;
			}
			else if (Object1.AuthenticationProviderName == null ^ Object2.AuthenticationProviderName == null )
			{
				equal = false;
			}
			if ( Object1.RoleProviderName != null && Object2.RoleProviderName != null )
			{
				if (Object1.RoleProviderName != Object2.RoleProviderName)
					equal = false;
			}
			else if (Object1.RoleProviderName == null ^ Object2.RoleProviderName == null )
			{
				equal = false;
			}
			if (Object1.TokenLife != Object2.TokenLife)
				equal = false;
			if ( Object1.AdminApplication != null && Object2.AdminApplication != null )
			{
				if (Object1.AdminApplication != Object2.AdminApplication)
					equal = false;
			}
			else if (Object1.AdminApplication == null ^ Object2.AdminApplication == null )
			{
				equal = false;
			}
					
			return equal;
		}
		
		#endregion
		
		#region IComparable Members
		///<summary>
		/// Compares this instance to a specified object and returns an indication of their relative values.
		///<param name="obj">An object to compare to this instance, or a null reference (Nothing in Visual Basic).</param>
		///</summary>
		///<returns>A signed integer that indicates the relative order of this instance and obj.</returns>
		public virtual int CompareTo(object obj)
		{
			throw new NotImplementedException();
			//return this. GetPropertyName(SourceTable.PrimaryKey.MemberColumns[0]) .CompareTo(((RealmBase)obj).GetPropertyName(SourceTable.PrimaryKey.MemberColumns[0]));
		}
		
		/*
		// static method to get a Comparer object
        public static RealmComparer GetComparer()
        {
            return new RealmComparer();
        }
        */

        // Comparer delegates back to Realm
        // Employee uses the integer's default
        // CompareTo method
        /*
        public int CompareTo(Item rhs)
        {
            return this.Id.CompareTo(rhs.Id);
        }
        */

/*
        // Special implementation to be called by custom comparer
        public int CompareTo(Realm rhs, RealmColumn which)
        {
            switch (which)
            {
            	
            	
            	case RealmColumn.RealmId:
            		return this.RealmId.CompareTo(rhs.RealmId);
            		
            		                 
            	
            	
            	case RealmColumn.Realm:
            		return this.Realm.CompareTo(rhs.Realm);
            		
            		                 
            	
            	
            	case RealmColumn.AuthenticationProviderName:
            		return this.AuthenticationProviderName.CompareTo(rhs.AuthenticationProviderName);
            		
            		                 
            	
            	
            	case RealmColumn.RoleProviderName:
            		return this.RoleProviderName.CompareTo(rhs.RoleProviderName);
            		
            		                 
            	
            	
            	case RealmColumn.TokenLife:
            		return this.TokenLife.CompareTo(rhs.TokenLife);
            		
            		                 
            	
            	
            	case RealmColumn.AdminApplication:
            		return this.AdminApplication.Value.CompareTo(rhs.AdminApplication.Value);
            		
            		                 
            }
            return 0;
        }
        */
	
		#endregion
		
		#region IComponent Members
		
		private ISite _site = null;

		/// <summary>
		/// Gets or Sets the site where this data is located.
		/// </summary>
		[XmlIgnore]
		[SoapIgnore]
		[Browsable(false)]
		public ISite Site
		{
			get{ return this._site; }
			set{ this._site = value; }
		}

		#endregion

		#region IDisposable Members
		
		/// <summary>
		/// Notify those that care when we dispose.
		/// </summary>
		[field:NonSerialized]
		public event System.EventHandler Disposed;

		/// <summary>
		/// Clean up. Nothing here though.
		/// </summary>
		public virtual void Dispose()
		{
			this.parentCollection = null;
			this.Dispose(true);
			GC.SuppressFinalize(this);
		}
		
		/// <summary>
		/// Clean up.
		/// </summary>
		protected virtual void Dispose(bool disposing)
		{
			if (disposing)
			{
				EventHandler handler = Disposed;
				if (handler != null)
					handler(this, EventArgs.Empty);
			}
		}
		
		#endregion
				
		#region IEntityKey<RealmKey> Members
		
		// member variable for the EntityId property
		private RealmKey _entityId;

		/// <summary>
		/// Gets or sets the EntityId property.
		/// </summary>
		[XmlIgnore]
		public virtual RealmKey EntityId
		{
			get
			{
				if ( _entityId == null )
				{
					_entityId = new RealmKey(this);
				}

				return _entityId;
			}
			set
			{
				if ( value != null )
				{
					value.Entity = this;
				}
				
				_entityId = value;
			}
		}
		
		#endregion
		
		#region EntityState
		/// <summary>
		///		Indicates state of object
		/// </summary>
		/// <remarks>0=Unchanged, 1=Added, 2=Changed</remarks>
		[BrowsableAttribute(false) , XmlIgnoreAttribute()]
		public override EntityState EntityState 
		{ 
			get{ return entityData.EntityState;	 } 
			set{ entityData.EntityState = value; } 
		}
		#endregion 
		
		#region EntityTrackingKey
		///<summary>
		/// Provides the tracking key for the <see cref="EntityLocator"/>
		///</summary>
		[XmlIgnore]
		public override string EntityTrackingKey
		{
			get
			{
				if(entityTrackingKey == null)
					entityTrackingKey = new System.Text.StringBuilder("Realm")
					.Append("|").Append( this.RealmId.ToString()).ToString();
				return entityTrackingKey;
			}
			set
		    {
		        if (value != null)
                    entityTrackingKey = value;
		    }
		}
		#endregion 
		
		#region ToString Method
		
		///<summary>
		/// Returns a String that represents the current object.
		///</summary>
		public override string ToString()
		{
			return string.Format(System.Globalization.CultureInfo.InvariantCulture,
				"{7}{6}- RealmId: {0}{6}- Realm: {1}{6}- AuthenticationProviderName: {2}{6}- RoleProviderName: {3}{6}- TokenLife: {4}{6}- AdminApplication: {5}{6}{8}", 
				this.RealmId,
				this.Realm,
				(this.AuthenticationProviderName == null) ? string.Empty : this.AuthenticationProviderName.ToString(),
				(this.RoleProviderName == null) ? string.Empty : this.RoleProviderName.ToString(),
				this.TokenLife,
				(this.AdminApplication == null) ? string.Empty : this.AdminApplication.ToString(),
				System.Environment.NewLine, 
				this.GetType(),
				this.Error.Length == 0 ? string.Empty : string.Format("- Error: {0}\n",this.Error));
		}
		
		#endregion ToString Method
		
		#region Inner data class
		
	/// <summary>
	///		The data structure representation of the 'Realm' table.
	/// </summary>
	/// <remarks>
	/// 	This struct is generated by a tool and should never be modified.
	/// </remarks>
	[EditorBrowsable(EditorBrowsableState.Never)]
	[Serializable]
	internal protected class RealmEntityData : ICloneable, ICloneableEx
	{
		#region Variable Declarations
		private EntityState currentEntityState = EntityState.Added;
		
		#region Primary key(s)
		/// <summary>			
		/// RealmID : 
		/// </summary>
		/// <remarks>Member of the primary key of the underlying table "Realm"</remarks>
		public System.Guid RealmId;
			
		/// <summary>
		/// keep a copy of the original so it can be used for editable primary keys.
		/// </summary>
		public System.Guid OriginalRealmId;
		
		#endregion
		
		#region Non Primary key(s)
		
		/// <summary>
		/// Realm : 
		/// </summary>
		public System.String Realm = string.Empty;
		
		/// <summary>
		/// AuthenticationProviderName : 
		/// </summary>
		public System.String AuthenticationProviderName = null;
		
		/// <summary>
		/// RoleProviderName : 
		/// </summary>
		public System.String RoleProviderName = null;
		
		/// <summary>
		/// TokenLife : 
		/// </summary>
		public System.Int32 TokenLife = (int)0;
		
		/// <summary>
		/// AdminApplication : 
		/// </summary>
		public System.Guid? AdminApplication = null;
		#endregion
			
		#region Source Foreign Key Property
				
		#endregion
        
		#endregion Variable Declarations

		#region Data Properties

		#region ApplicationDefinationCollection
		
		private TList<ApplicationDefination> _applicationDefinationRealm;
		
		/// <summary>
		///	Holds a collection of entity objects
		///	which are related to this object through the relation _applicationDefinationRealm
		/// </summary>
		
		public TList<ApplicationDefination> ApplicationDefinationCollection
		{
			get
			{
				if (_applicationDefinationRealm == null)
				{
				_applicationDefinationRealm = new TList<ApplicationDefination>();
				}
	
				return _applicationDefinationRealm;
			}
			set { _applicationDefinationRealm = value; }
		}
		
		#endregion

		#region SecurityTokenCollection
		
		private TList<SecurityToken> _securityTokenRealm;
		
		/// <summary>
		///	Holds a collection of entity objects
		///	which are related to this object through the relation _securityTokenRealm
		/// </summary>
		
		public TList<SecurityToken> SecurityTokenCollection
		{
			get
			{
				if (_securityTokenRealm == null)
				{
				_securityTokenRealm = new TList<SecurityToken>();
				}
	
				return _securityTokenRealm;
			}
			set { _securityTokenRealm = value; }
		}
		
		#endregion

		#endregion Data Properties
		#region Clone Method

		/// <summary>
		/// Creates a new object that is a copy of the current instance.
		/// </summary>
		/// <returns>A new object that is a copy of this instance.</returns>
		public Object Clone()
		{
			RealmEntityData _tmp = new RealmEntityData();
						
			_tmp.RealmId = this.RealmId;
			_tmp.OriginalRealmId = this.OriginalRealmId;
			
			_tmp.Realm = this.Realm;
			_tmp.AuthenticationProviderName = this.AuthenticationProviderName;
			_tmp.RoleProviderName = this.RoleProviderName;
			_tmp.TokenLife = this.TokenLife;
			_tmp.AdminApplication = this.AdminApplication;
			
			#region Source Parent Composite Entities
			#endregion
		
			#region Child Collections
			//deep copy nested objects
			if (this._applicationDefinationRealm != null)
				_tmp.ApplicationDefinationCollection = (TList<ApplicationDefination>) MakeCopyOf(this.ApplicationDefinationCollection); 
			if (this._securityTokenRealm != null)
				_tmp.SecurityTokenCollection = (TList<SecurityToken>) MakeCopyOf(this.SecurityTokenCollection); 
			#endregion Child Collections
			
			//EntityState
			_tmp.EntityState = this.EntityState;
			
			return _tmp;
		}
		
		/// <summary>
		/// Creates a new object that is a copy of the current instance.
		/// </summary>
		/// <returns>A new object that is a copy of this instance.</returns>
		public object Clone(IDictionary existingCopies)
		{
			if (existingCopies == null)
				existingCopies = new Hashtable();
				
			RealmEntityData _tmp = new RealmEntityData();
						
			_tmp.RealmId = this.RealmId;
			_tmp.OriginalRealmId = this.OriginalRealmId;
			
			_tmp.Realm = this.Realm;
			_tmp.AuthenticationProviderName = this.AuthenticationProviderName;
			_tmp.RoleProviderName = this.RoleProviderName;
			_tmp.TokenLife = this.TokenLife;
			_tmp.AdminApplication = this.AdminApplication;
			
			#region Source Parent Composite Entities
			#endregion
		
			#region Child Collections
			//deep copy nested objects
			_tmp.ApplicationDefinationCollection = (TList<ApplicationDefination>) MakeCopyOf(this.ApplicationDefinationCollection, existingCopies); 
			_tmp.SecurityTokenCollection = (TList<SecurityToken>) MakeCopyOf(this.SecurityTokenCollection, existingCopies); 
			#endregion Child Collections
			
			//EntityState
			_tmp.EntityState = this.EntityState;
			
			return _tmp;
		}
		
		#endregion Clone Method
		
		/// <summary>
		///		Indicates state of object
		/// </summary>
		/// <remarks>0=Unchanged, 1=Added, 2=Changed</remarks>
		[BrowsableAttribute(false), XmlIgnoreAttribute()]
		public EntityState	EntityState
		{
			get { return currentEntityState;  }
			set { currentEntityState = value; }
		}
	
	}//End struct

		#endregion
		
				
		
		#region Events trigger
		/// <summary>
		/// Raises the <see cref="ColumnChanging" /> event.
		/// </summary>
		/// <param name="column">The <see cref="RealmColumn"/> which has raised the event.</param>
		public virtual void OnColumnChanging(RealmColumn column)
		{
			OnColumnChanging(column, null);
			return;
		}
		
		/// <summary>
		/// Raises the <see cref="ColumnChanged" /> event.
		/// </summary>
		/// <param name="column">The <see cref="RealmColumn"/> which has raised the event.</param>
		public virtual void OnColumnChanged(RealmColumn column)
		{
			OnColumnChanged(column, null);
			return;
		} 
		
		
		/// <summary>
		/// Raises the <see cref="ColumnChanging" /> event.
		/// </summary>
		/// <param name="column">The <see cref="RealmColumn"/> which has raised the event.</param>
		/// <param name="value">The changed value.</param>
		public virtual void OnColumnChanging(RealmColumn column, object value)
		{
			if(IsEntityTracked && EntityState != EntityState.Added && !EntityManager.TrackChangedEntities)
				EntityManager.StopTracking(entityTrackingKey);
				
			if (!SuppressEntityEvents)
			{
				RealmEventHandler handler = ColumnChanging;
				if(handler != null)
				{
					handler(this, new RealmEventArgs(column, value));
				}
			}
		}
		
		/// <summary>
		/// Raises the <see cref="ColumnChanged" /> event.
		/// </summary>
		/// <param name="column">The <see cref="RealmColumn"/> which has raised the event.</param>
		/// <param name="value">The changed value.</param>
		public virtual void OnColumnChanged(RealmColumn column, object value)
		{
			if (!SuppressEntityEvents)
			{
				RealmEventHandler handler = ColumnChanged;
				if(handler != null)
				{
					handler(this, new RealmEventArgs(column, value));
				}
			
				// warn the parent list that i have changed
				OnEntityChanged();
			}
		} 
		#endregion
			
	} // End Class
	
	
	#region RealmEventArgs class
	/// <summary>
	/// Provides data for the ColumnChanging and ColumnChanged events.
	/// </summary>
	/// <remarks>
	/// The ColumnChanging and ColumnChanged events occur when a change is made to the value 
	/// of a property of a <see cref="Realm"/> object.
	/// </remarks>
	public class RealmEventArgs : System.EventArgs
	{
		private RealmColumn column;
		private object value;
		
		///<summary>
		/// Initalizes a new Instance of the RealmEventArgs class.
		///</summary>
		public RealmEventArgs(RealmColumn column)
		{
			this.column = column;
		}
		
		///<summary>
		/// Initalizes a new Instance of the RealmEventArgs class.
		///</summary>
		public RealmEventArgs(RealmColumn column, object value)
		{
			this.column = column;
			this.value = value;
		}
		
		///<summary>
		/// The RealmColumn that was modified, which has raised the event.
		///</summary>
		///<value cref="RealmColumn" />
		public RealmColumn Column { get { return this.column; } }
		
		/// <summary>
        /// Gets the current value of the column.
        /// </summary>
        /// <value>The current value of the column.</value>
		public object Value{ get { return this.value; } }

	}
	#endregion
	
	///<summary>
	/// Define a delegate for all Realm related events.
	///</summary>
	public delegate void RealmEventHandler(object sender, RealmEventArgs e);
	
	#region RealmComparer
		
	/// <summary>
	///	Strongly Typed IComparer
	/// </summary>
	public class RealmComparer : System.Collections.Generic.IComparer<Realm>
	{
		RealmColumn whichComparison;
		
		/// <summary>
        /// Initializes a new instance of the <see cref="T:RealmComparer"/> class.
        /// </summary>
		public RealmComparer()
        {            
        }               
        
        /// <summary>
        /// Initializes a new instance of the <see cref="T:RealmComparer"/> class.
        /// </summary>
        /// <param name="column">The column to sort on.</param>
        public RealmComparer(RealmColumn column)
        {
            this.whichComparison = column;
        }

		/// <summary>
        /// Determines whether the specified <see cref="Realm"/> instances are considered equal.
        /// </summary>
        /// <param name="a">The first <see cref="Realm"/> to compare.</param>
        /// <param name="b">The second <c>Realm</c> to compare.</param>
        /// <returns>true if objA is the same instance as objB or if both are null references or if objA.Equals(objB) returns true; otherwise, false.</returns>
        public bool Equals(Realm a, Realm b)
        {
            return this.Compare(a, b) == 0;
        }

		/// <summary>
        /// Gets the hash code of the specified entity.
        /// </summary>
        /// <param name="entity">The entity.</param>
        /// <returns></returns>
        public int GetHashCode(Realm entity)
        {
            return entity.GetHashCode();
        }

        /// <summary>
        /// Performs a case-insensitive comparison of two objects of the same type and returns a value indicating whether one is less than, equal to, or greater than the other.
        /// </summary>
        /// <param name="a">The first object to compare.</param>
        /// <param name="b">The second object to compare.</param>
        /// <returns></returns>
        public int Compare(Realm a, Realm b)
        {
        	EntityPropertyComparer entityPropertyComparer = new EntityPropertyComparer(this.whichComparison.ToString());
        	return entityPropertyComparer.Compare(a, b);
        }

		/// <summary>
        /// Gets or sets the column that will be used for comparison.
        /// </summary>
        /// <value>The comparison column.</value>
        public RealmColumn WhichComparison
        {
            get { return this.whichComparison; }
            set { this.whichComparison = value; }
        }
	}
	
	#endregion
	
	#region RealmKey Class

	/// <summary>
	/// Wraps the unique identifier values for the <see cref="Realm"/> object.
	/// </summary>
	[Serializable]
	[CLSCompliant(true)]
	public class RealmKey : EntityKeyBase
	{
		#region Constructors
		
		/// <summary>
		/// Initializes a new instance of the RealmKey class.
		/// </summary>
		public RealmKey()
		{
		}
		
		/// <summary>
		/// Initializes a new instance of the RealmKey class.
		/// </summary>
		public RealmKey(RealmBase entity)
		{
			this.Entity = entity;

			#region Init Properties

			if ( entity != null )
			{
				this.RealmId = entity.RealmId;
			}

			#endregion
		}
		
		/// <summary>
		/// Initializes a new instance of the RealmKey class.
		/// </summary>
		public RealmKey(System.Guid _realmId)
		{
			#region Init Properties

			this.RealmId = _realmId;

			#endregion
		}
		
		#endregion Constructors

		#region Properties
		
		// member variable for the Entity property
		private RealmBase _entity;
		
		/// <summary>
		/// Gets or sets the Entity property.
		/// </summary>
		public RealmBase Entity
		{
			get { return _entity; }
			set { _entity = value; }
		}
		
		// member variable for the RealmId property
		private System.Guid _realmId;
		
		/// <summary>
		/// Gets or sets the RealmId property.
		/// </summary>
		public System.Guid RealmId
		{
			get { return _realmId; }
			set
			{
				if ( this.Entity != null )
					this.Entity.RealmId = value;
				
				_realmId = value;
			}
		}
		
		#endregion

		#region Methods
		
		/// <summary>
		/// Reads values from the supplied <see cref="IDictionary"/> object into
		/// properties of the current object.
		/// </summary>
		/// <param name="values">An <see cref="IDictionary"/> instance that contains
		/// the key/value pairs to be used as property values.</param>
		public override void Load(IDictionary values)
		{
			#region Init Properties

			if ( values != null )
			{
				RealmId = ( values["RealmId"] != null ) ? (System.Guid) EntityUtil.ChangeType(values["RealmId"], typeof(System.Guid)) : Guid.Empty;
			}

			#endregion
		}

		/// <summary>
		/// Creates a new <see cref="IDictionary"/> object and populates it
		/// with the property values of the current object.
		/// </summary>
		/// <returns>A collection of name/value pairs.</returns>
		public override IDictionary ToDictionary()
		{
			IDictionary values = new Hashtable();

			#region Init Dictionary

			values.Add("RealmId", RealmId);

			#endregion Init Dictionary

			return values;
		}
		
		///<summary>
		/// Returns a String that represents the current object.
		///</summary>
		public override string ToString()
		{
			return String.Format("RealmId: {0}{1}",
								RealmId,
								System.Environment.NewLine);
		}

		#endregion Methods
	}
	
	#endregion	

	#region RealmColumn Enum
	
	/// <summary>
	/// Enumerate the Realm columns.
	/// </summary>
	[Serializable]
	public enum RealmColumn : int
	{
		/// <summary>
		/// RealmId : 
		/// </summary>
		[EnumTextValue("RealmID")]
		[ColumnEnum("RealmID", typeof(System.Guid), System.Data.DbType.Guid, true, false, false)]
		RealmId = 1,
		/// <summary>
		/// Realm : 
		/// </summary>
		[EnumTextValue("Realm")]
		[ColumnEnum("Realm", typeof(System.String), System.Data.DbType.String, false, false, false, 50)]
		Realm = 2,
		/// <summary>
		/// AuthenticationProviderName : 
		/// </summary>
		[EnumTextValue("AuthenticationProviderName")]
		[ColumnEnum("AuthenticationProviderName", typeof(System.String), System.Data.DbType.String, false, false, true, 50)]
		AuthenticationProviderName = 3,
		/// <summary>
		/// RoleProviderName : 
		/// </summary>
		[EnumTextValue("RoleProviderName")]
		[ColumnEnum("RoleProviderName", typeof(System.String), System.Data.DbType.String, false, false, true, 50)]
		RoleProviderName = 4,
		/// <summary>
		/// TokenLife : 
		/// </summary>
		[EnumTextValue("TokenLife")]
		[ColumnEnum("TokenLife", typeof(System.Int32), System.Data.DbType.Int32, false, false, false)]
		TokenLife = 5,
		/// <summary>
		/// AdminApplication : 
		/// </summary>
		[EnumTextValue("AdminApplication")]
		[ColumnEnum("AdminApplication", typeof(System.Guid), System.Data.DbType.Guid, false, false, true)]
		AdminApplication = 6
	}//End enum

	#endregion RealmColumn Enum

} // end namespace
