﻿
/*
	File generated by NetTiers templates [www.nettiers.com]
	Important: Do not modify this file. Edit the file SecurityToken.cs instead.
*/

#region using directives
using System;
using System.ComponentModel;
using System.Collections;
using System.Xml.Serialization;
using System.Runtime.Serialization;

using SecurityFoundation.Entities.Validation;
#endregion

namespace SecurityFoundation.Entities
{
	///<summary>
	/// An object representation of the 'SecurityToken' table. [No description found the database]	
	///</summary>
	[Serializable]
	[DataObject, CLSCompliant(true)]
	public abstract partial class SecurityTokenBase : EntityBase, ISecurityToken, IEntityId<SecurityTokenKey>, System.IComparable, System.ICloneable, ICloneableEx, IEditableObject, IComponent, INotifyPropertyChanged
	{		
		#region Variable Declarations
		
		/// <summary>
		///  Hold the inner data of the entity.
		/// </summary>
		private SecurityTokenEntityData entityData;
		
		/// <summary>
		/// 	Hold the original data of the entity, as loaded from the repository.
		/// </summary>
		private SecurityTokenEntityData _originalData;
		
		/// <summary>
		/// 	Hold a backup of the inner data of the entity.
		/// </summary>
		private SecurityTokenEntityData backupData; 
		
		/// <summary>
		/// 	Key used if Tracking is Enabled for the <see cref="EntityLocator" />.
		/// </summary>
		private string entityTrackingKey;
		
		/// <summary>
		/// 	Hold the parent TList&lt;entity&gt; in which this entity maybe contained.
		/// </summary>
		/// <remark>Mostly used for databinding</remark>
		[NonSerialized]
		private TList<SecurityToken> parentCollection;
		
		private bool inTxn = false;
		
		/// <summary>
		/// Occurs when a value is being changed for the specified column.
		/// </summary>
		[field:NonSerialized]
		public event SecurityTokenEventHandler ColumnChanging;		
		
		/// <summary>
		/// Occurs after a value has been changed for the specified column.
		/// </summary>
		[field:NonSerialized]
		public event SecurityTokenEventHandler ColumnChanged;
		
		#endregion Variable Declarations
		
		#region Constructors
		///<summary>
		/// Creates a new <see cref="SecurityTokenBase"/> instance.
		///</summary>
		public SecurityTokenBase()
		{
			this.entityData = new SecurityTokenEntityData();
			this.backupData = null;
		}		
		
		///<summary>
		/// Creates a new <see cref="SecurityTokenBase"/> instance.
		///</summary>
		///<param name="_tokenKey"></param>
		///<param name="_realm"></param>
		///<param name="_sourceApplication"></param>
		///<param name="_tokenCreated"></param>
		///<param name="_userName"></param>
		public SecurityTokenBase(System.Guid _tokenKey, System.Guid _realm, System.Guid _sourceApplication, 
			System.DateTime _tokenCreated, System.String _userName)
		{
			this.entityData = new SecurityTokenEntityData();
			this.backupData = null;

			this.TokenKey = _tokenKey;
			this.Realm = _realm;
			this.SourceApplication = _sourceApplication;
			this.TokenCreated = _tokenCreated;
			this.UserName = _userName;
		}
		
		///<summary>
		/// A simple factory method to create a new <see cref="SecurityToken"/> instance.
		///</summary>
		///<param name="_tokenKey"></param>
		///<param name="_realm"></param>
		///<param name="_sourceApplication"></param>
		///<param name="_tokenCreated"></param>
		///<param name="_userName"></param>
		public static SecurityToken CreateSecurityToken(System.Guid _tokenKey, System.Guid _realm, System.Guid _sourceApplication, 
			System.DateTime _tokenCreated, System.String _userName)
		{
			SecurityToken newSecurityToken = new SecurityToken();
			newSecurityToken.TokenKey = _tokenKey;
			newSecurityToken.Realm = _realm;
			newSecurityToken.SourceApplication = _sourceApplication;
			newSecurityToken.TokenCreated = _tokenCreated;
			newSecurityToken.UserName = _userName;
			return newSecurityToken;
		}
				
		#endregion Constructors
			
		#region Properties	
		
		#region Data Properties		
		/// <summary>
		/// 	Gets or sets the TokenKey property. 
		///		
		/// </summary>
		/// <value>This type is uniqueidentifier.</value>
		/// <remarks>
		/// This property can not be set to null. 
		/// </remarks>




		[DescriptionAttribute(@""), System.ComponentModel.Bindable( System.ComponentModel.BindableSupport.Yes)]
		[DataObjectField(true, false, false)]
		public virtual System.Guid TokenKey
		{
			get
			{
				return this.entityData.TokenKey; 
			}
			
			set
			{
				if (this.entityData.TokenKey == value)
					return;
				
                OnPropertyChanging("TokenKey");                    
				OnColumnChanging(SecurityTokenColumn.TokenKey, this.entityData.TokenKey);
				this.entityData.TokenKey = value;
				this.EntityId.TokenKey = value;
				if (this.EntityState == EntityState.Unchanged)
					this.EntityState = EntityState.Changed;
				OnColumnChanged(SecurityTokenColumn.TokenKey, this.entityData.TokenKey);
				OnPropertyChanged("TokenKey");
			}
		}
		
		/// <summary>
		/// 	Get the original value of the TokenKey property.
		///		
		/// </summary>
		/// <remarks>This is the original value of the TokenKey property.</remarks>
		/// <value>This type is uniqueidentifier</value>
		[BrowsableAttribute(false)/*, XmlIgnoreAttribute()*/]
		public  virtual System.Guid OriginalTokenKey
		{
			get { return this.entityData.OriginalTokenKey; }
			set { this.entityData.OriginalTokenKey = value; }
		}
		
		/// <summary>
		/// 	Gets or sets the Realm property. 
		///		
		/// </summary>
		/// <value>This type is uniqueidentifier.</value>
		/// <remarks>
		/// This property can not be set to null. 
		/// </remarks>




		[DescriptionAttribute(@""), System.ComponentModel.Bindable( System.ComponentModel.BindableSupport.Yes)]
		[DataObjectField(false, false, false)]
		public virtual System.Guid Realm
		{
			get
			{
				return this.entityData.Realm; 
			}
			
			set
			{
				if (this.entityData.Realm == value)
					return;
				
                OnPropertyChanging("Realm");                    
				OnColumnChanging(SecurityTokenColumn.Realm, this.entityData.Realm);
				this.entityData.Realm = value;
				if (this.EntityState == EntityState.Unchanged)
					this.EntityState = EntityState.Changed;
				OnColumnChanged(SecurityTokenColumn.Realm, this.entityData.Realm);
				OnPropertyChanged("Realm");
			}
		}
		
		/// <summary>
		/// 	Gets or sets the SourceApplication property. 
		///		
		/// </summary>
		/// <value>This type is uniqueidentifier.</value>
		/// <remarks>
		/// This property can not be set to null. 
		/// </remarks>




		[DescriptionAttribute(@""), System.ComponentModel.Bindable( System.ComponentModel.BindableSupport.Yes)]
		[DataObjectField(false, false, false)]
		public virtual System.Guid SourceApplication
		{
			get
			{
				return this.entityData.SourceApplication; 
			}
			
			set
			{
				if (this.entityData.SourceApplication == value)
					return;
				
                OnPropertyChanging("SourceApplication");                    
				OnColumnChanging(SecurityTokenColumn.SourceApplication, this.entityData.SourceApplication);
				this.entityData.SourceApplication = value;
				if (this.EntityState == EntityState.Unchanged)
					this.EntityState = EntityState.Changed;
				OnColumnChanged(SecurityTokenColumn.SourceApplication, this.entityData.SourceApplication);
				OnPropertyChanged("SourceApplication");
			}
		}
		
		/// <summary>
		/// 	Gets or sets the TokenCreated property. 
		///		
		/// </summary>
		/// <value>This type is datetime.</value>
		/// <remarks>
		/// This property can not be set to null. 
		/// </remarks>




		[DescriptionAttribute(@""), System.ComponentModel.Bindable( System.ComponentModel.BindableSupport.Yes)]
		[DataObjectField(false, false, false)]
		public virtual System.DateTime TokenCreated
		{
			get
			{
				return this.entityData.TokenCreated; 
			}
			
			set
			{
				if (this.entityData.TokenCreated == value)
					return;
				
                OnPropertyChanging("TokenCreated");                    
				OnColumnChanging(SecurityTokenColumn.TokenCreated, this.entityData.TokenCreated);
				this.entityData.TokenCreated = value;
				if (this.EntityState == EntityState.Unchanged)
					this.EntityState = EntityState.Changed;
				OnColumnChanged(SecurityTokenColumn.TokenCreated, this.entityData.TokenCreated);
				OnPropertyChanged("TokenCreated");
			}
		}
		
		/// <summary>
		/// 	Gets or sets the UserName property. 
		///		
		/// </summary>
		/// <value>This type is nvarchar.</value>
		/// <remarks>
		/// This property can not be set to null. 
		/// </remarks>
		/// <exception cref="ArgumentNullException">If you attempt to set to null.</exception>




		[DescriptionAttribute(@""), System.ComponentModel.Bindable( System.ComponentModel.BindableSupport.Yes)]
		[DataObjectField(false, false, false, 1024)]
		public virtual System.String UserName
		{
			get
			{
				return this.entityData.UserName; 
			}
			
			set
			{
				if (this.entityData.UserName == value)
					return;
				
                OnPropertyChanging("UserName");                    
				OnColumnChanging(SecurityTokenColumn.UserName, this.entityData.UserName);
				this.entityData.UserName = value;
				if (this.EntityState == EntityState.Unchanged)
					this.EntityState = EntityState.Changed;
				OnColumnChanged(SecurityTokenColumn.UserName, this.entityData.UserName);
				OnPropertyChanged("UserName");
			}
		}
		
		#endregion Data Properties		

		#region Source Foreign Key Property
				
		/// <summary>
		/// Gets or sets the source <see cref="ApplicationDefination"/>.
		/// </summary>
		/// <value>The source ApplicationDefination for SourceApplication.</value>
        [XmlIgnore()]
		[Browsable(false), System.ComponentModel.Bindable(System.ComponentModel.BindableSupport.Yes)]
		public virtual ApplicationDefination SourceApplicationSource
      	{
            get { return entityData.SourceApplicationSource; }
            set { entityData.SourceApplicationSource = value; }
      	}
		/// <summary>
		/// Gets or sets the source <see cref="Realm"/>.
		/// </summary>
		/// <value>The source Realm for Realm.</value>
        [XmlIgnore()]
		[Browsable(false), System.ComponentModel.Bindable(System.ComponentModel.BindableSupport.Yes)]
		public virtual Realm RealmSource
      	{
            get { return entityData.RealmSource; }
            set { entityData.RealmSource = value; }
      	}
		#endregion
		
		#region Children Collections
		#endregion Children Collections
		
		#endregion
		#region Validation
		
		/// <summary>
		/// Assigns validation rules to this object based on model definition.
		/// </summary>
		/// <remarks>This method overrides the base class to add schema related validation.</remarks>
		protected override void AddValidationRules()
		{
			//Validation rules based on database schema.
			ValidationRules.AddRule( CommonRules.NotNull,
				new ValidationRuleArgs("UserName", "User Name"));
			ValidationRules.AddRule( CommonRules.StringMaxLength, 
				new CommonRules.MaxLengthRuleArgs("UserName", "User Name", 1024));
		}
   		#endregion
		
		#region Table Meta Data
		/// <summary>
		///		The name of the underlying database table.
		/// </summary>
		[BrowsableAttribute(false), XmlIgnoreAttribute()]
		public override string TableName
		{
			get { return "SecurityToken"; }
		}
		
		/// <summary>
		///		The name of the underlying database table's columns.
		/// </summary>
		[BrowsableAttribute(false), XmlIgnoreAttribute()]
		public override string[] TableColumns
		{
			get
			{
				return new string[] {"TokenKey", "Realm", "SourceApplication", "TokenCreated", "UserName"};
			}
		}
		#endregion 
		
		#region IEditableObject
		
		#region  CancelAddNew Event
		/// <summary>
        /// The delegate for the CancelAddNew event.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
		public delegate void CancelAddNewEventHandler(object sender, EventArgs e);
    
    	/// <summary>
		/// The CancelAddNew event.
		/// </summary>
		[field:NonSerialized]
		public event CancelAddNewEventHandler CancelAddNew ;

		/// <summary>
        /// Called when [cancel add new].
        /// </summary>
        public void OnCancelAddNew()
        {    
			if (!SuppressEntityEvents)
			{
	            CancelAddNewEventHandler handler = CancelAddNew ;
            	if (handler != null)
	            {    
    	            handler(this, EventArgs.Empty) ;
        	    }
	        }
        }
		#endregion 
		
		/// <summary>
		/// Begins an edit on an object.
		/// </summary>
		void IEditableObject.BeginEdit() 
	    {
	        //Console.WriteLine("Start BeginEdit");
	        if (!inTxn) 
	        {
	            this.backupData = this.entityData.Clone() as SecurityTokenEntityData;
	            inTxn = true;
	            //Console.WriteLine("BeginEdit");
	        }
	        //Console.WriteLine("End BeginEdit");
	    }
	
		/// <summary>
		/// Discards changes since the last <c>BeginEdit</c> call.
		/// </summary>
	    void IEditableObject.CancelEdit() 
	    {
	        //Console.WriteLine("Start CancelEdit");
	        if (this.inTxn) 
	        {
	            this.entityData = this.backupData;
	            this.backupData = null;
				this.inTxn = false;

				if (this.bindingIsNew)
	        	//if (this.EntityState == EntityState.Added)
	        	{
					if (this.parentCollection != null)
						this.parentCollection.Remove( (SecurityToken) this ) ;
				}	            
	        }
	        //Console.WriteLine("End CancelEdit");
	    }
	
		/// <summary>
		/// Pushes changes since the last <c>BeginEdit</c> or <c>IBindingList.AddNew</c> call into the underlying object.
		/// </summary>
	    void IEditableObject.EndEdit() 
	    {
	        //Console.WriteLine("Start EndEdit" + this.custData.id + this.custData.lastName);
	        if (this.inTxn) 
	        {
	            this.backupData = null;
				if (this.IsDirty) 
				{
					if (this.bindingIsNew) {
						this.EntityState = EntityState.Added;
						this.bindingIsNew = false ;
					}
					else
						if (this.EntityState == EntityState.Unchanged) 
							this.EntityState = EntityState.Changed ;
				}

				this.bindingIsNew = false ;
	            this.inTxn = false;	            
	        }
	        //Console.WriteLine("End EndEdit");
	    }
	    
	    /// <summary>
        /// Gets or sets the parent collection of this current entity, if available.
        /// </summary>
        /// <value>The parent collection.</value>
	    [XmlIgnore]
		[Browsable(false)]
	    public override object ParentCollection
	    {
	        get 
	        {
	            return this.parentCollection;
	        }
	        set 
	        {
	            this.parentCollection = value as TList<SecurityToken>;
	        }
	    }
	    
	    /// <summary>
        /// Called when the entity is changed.
        /// </summary>
	    private void OnEntityChanged() 
	    {
	        if (!SuppressEntityEvents && !inTxn && this.parentCollection != null) 
	        {
	            this.parentCollection.EntityChanged(this as SecurityToken);
	        }
	    }


		#endregion
		
		#region ICloneable Members
		///<summary>
		///  Returns a Typed SecurityToken Entity 
		///</summary>
		protected virtual SecurityToken Copy(IDictionary existingCopies)
		{
			if (existingCopies == null)
			{
				// This is the root of the tree to be copied!
				existingCopies = new Hashtable();
			}

			//shallow copy entity
			SecurityToken copy = new SecurityToken();
			existingCopies.Add(this, copy);
			copy.SuppressEntityEvents = true;
				copy.TokenKey = this.TokenKey;
					copy.OriginalTokenKey = this.OriginalTokenKey;
				copy.Realm = this.Realm;
				copy.SourceApplication = this.SourceApplication;
				copy.TokenCreated = this.TokenCreated;
				copy.UserName = this.UserName;
			
			if (this.SourceApplicationSource != null && existingCopies.Contains(this.SourceApplicationSource))
				copy.SourceApplicationSource = existingCopies[this.SourceApplicationSource] as ApplicationDefination;
			else
				copy.SourceApplicationSource = MakeCopyOf(this.SourceApplicationSource, existingCopies) as ApplicationDefination;
			if (this.RealmSource != null && existingCopies.Contains(this.RealmSource))
				copy.RealmSource = existingCopies[this.RealmSource] as Realm;
			else
				copy.RealmSource = MakeCopyOf(this.RealmSource, existingCopies) as Realm;
		
			copy.EntityState = this.EntityState;
			copy.SuppressEntityEvents = false;
			return copy;
		}		
		
		
		
		///<summary>
		///  Returns a Typed SecurityToken Entity 
		///</summary>
		public virtual SecurityToken Copy()
		{
			return this.Copy(null);	
		}
		
		///<summary>
		/// ICloneable.Clone() Member, returns the Shallow Copy of this entity.
		///</summary>
		public object Clone()
		{
			return this.Copy(null);
		}
		
		///<summary>
		/// ICloneableEx.Clone() Member, returns the Shallow Copy of this entity.
		///</summary>
		public object Clone(IDictionary existingCopies)
		{
			return this.Copy(existingCopies);
		}
		
		///<summary>
		/// Returns a deep copy of the child collection object passed in.
		///</summary>
		public static object MakeCopyOf(object x)
		{
			if (x == null)
				return null;
				
			if (x is ICloneable)
			{
				// Return a deep copy of the object
				return ((ICloneable)x).Clone();
			}
			else
				throw new System.NotSupportedException("Object Does Not Implement the ICloneable Interface.");
		}
		
		///<summary>
		/// Returns a deep copy of the child collection object passed in.
		///</summary>
		public static object MakeCopyOf(object x, IDictionary existingCopies)
		{
			if (x == null)
				return null;
			
			if (x is ICloneableEx)
			{
				// Return a deep copy of the object
				return ((ICloneableEx)x).Clone(existingCopies);
			}
			else if (x is ICloneable)
			{
				// Return a deep copy of the object
				return ((ICloneable)x).Clone();
			}
			else
				throw new System.NotSupportedException("Object Does Not Implement the ICloneable or IClonableEx Interface.");
		}
		
		
		///<summary>
		///  Returns a Typed SecurityToken Entity which is a deep copy of the current entity.
		///</summary>
		public virtual SecurityToken DeepCopy()
		{
			return EntityHelper.Clone<SecurityToken>(this as SecurityToken);	
		}
		#endregion
		
		#region Methods	
			
		///<summary>
		/// Revert all changes and restore original values.
		///</summary>
		public override void CancelChanges()
		{
			IEditableObject obj = (IEditableObject) this;
			obj.CancelEdit();

			this.entityData = null;
			if (this._originalData != null)
			{
				this.entityData = this._originalData.Clone() as SecurityTokenEntityData;
			}
			else
			{
				//Since this had no _originalData, then just reset the entityData with a new one.  entityData cannot be null.
				this.entityData = new SecurityTokenEntityData();
			}
		}	
		
		/// <summary>
		/// Accepts the changes made to this object.
		/// </summary>
		/// <remarks>
		/// After calling this method, properties: IsDirty, IsNew are false. IsDeleted flag remains unchanged as it is handled by the parent List.
		/// </remarks>
		public override void AcceptChanges()
		{
			base.AcceptChanges();

			// we keep of the original version of the data
			this._originalData = null;
			this._originalData = this.entityData.Clone() as SecurityTokenEntityData;
		}
		
		#region Comparision with original data
		
		/// <summary>
		/// Determines whether the property value has changed from the original data.
		/// </summary>
		/// <param name="column">The column.</param>
		/// <returns>
		/// 	<c>true</c> if the property value has changed; otherwise, <c>false</c>.
		/// </returns>
		public bool IsPropertyChanged(SecurityTokenColumn column)
		{
			switch(column)
			{
					case SecurityTokenColumn.TokenKey:
					return entityData.TokenKey != _originalData.TokenKey;
					case SecurityTokenColumn.Realm:
					return entityData.Realm != _originalData.Realm;
					case SecurityTokenColumn.SourceApplication:
					return entityData.SourceApplication != _originalData.SourceApplication;
					case SecurityTokenColumn.TokenCreated:
					return entityData.TokenCreated != _originalData.TokenCreated;
					case SecurityTokenColumn.UserName:
					return entityData.UserName != _originalData.UserName;
			
				default:
					return false;
			}
		}
		
		/// <summary>
		/// Determines whether the property value has changed from the original data.
		/// </summary>
		/// <param name="columnName">The column name.</param>
		/// <returns>
		/// 	<c>true</c> if the property value has changed; otherwise, <c>false</c>.
		/// </returns>
		public override bool IsPropertyChanged(string columnName)
		{
			return 	IsPropertyChanged(EntityHelper.GetEnumValue< SecurityTokenColumn >(columnName));
		}
		
		/// <summary>
		/// Determines whether the data has changed from original.
		/// </summary>
		/// <returns>
		/// 	<c>true</c> if data has changed; otherwise, <c>false</c>.
		/// </returns>
		public bool HasDataChanged()
		{
			bool result = false;
			result = result || entityData.TokenKey != _originalData.TokenKey;
			result = result || entityData.Realm != _originalData.Realm;
			result = result || entityData.SourceApplication != _originalData.SourceApplication;
			result = result || entityData.TokenCreated != _originalData.TokenCreated;
			result = result || entityData.UserName != _originalData.UserName;
			return result;
		}	
		
		///<summary>
		///  Returns a SecurityToken Entity with the original data.
		///</summary>
		public SecurityToken GetOriginalEntity()
		{
			if (_originalData != null)
				return CreateSecurityToken(
				_originalData.TokenKey,
				_originalData.Realm,
				_originalData.SourceApplication,
				_originalData.TokenCreated,
				_originalData.UserName
				);
				
			return (SecurityToken)this.Clone();
		}
		#endregion
	
	#region Value Semantics Instance Equality
        ///<summary>
        /// Returns a value indicating whether this instance is equal to a specified object using value semantics.
        ///</summary>
        ///<param name="Object1">An object to compare to this instance.</param>
        ///<returns>true if Object1 is a <see cref="SecurityTokenBase"/> and has the same value as this instance; otherwise, false.</returns>
        public override bool Equals(object Object1)
        {
			// Cast exception if Object1 is null or DbNull
			if (Object1 != null && Object1 != DBNull.Value && Object1 is SecurityTokenBase)
				return ValueEquals(this, (SecurityTokenBase)Object1);
			else
				return false;
        }

        /// <summary>
		/// Serves as a hash function for a particular type, suitable for use in hashing algorithms and data structures like a hash table.
        /// Provides a hash function that is appropriate for <see cref="SecurityTokenBase"/> class 
        /// and that ensures a better distribution in the hash table
        /// </summary>
        /// <returns>number (hash code) that corresponds to the value of an object</returns>
        public override int GetHashCode()
        {
			return this.TokenKey.GetHashCode() ^ 
					this.Realm.GetHashCode() ^ 
					this.SourceApplication.GetHashCode() ^ 
					this.TokenCreated.GetHashCode() ^ 
					this.UserName.GetHashCode();
        }
		
		///<summary>
		/// Returns a value indicating whether this instance is equal to a specified object using value semantics.
		///</summary>
		///<param name="toObject">An object to compare to this instance.</param>
		///<returns>true if toObject is a <see cref="SecurityTokenBase"/> and has the same value as this instance; otherwise, false.</returns>
		public virtual bool Equals(SecurityTokenBase toObject)
		{
			if (toObject == null)
				return false;
			return ValueEquals(this, toObject);
		}
		#endregion
		
		///<summary>
		/// Determines whether the specified <see cref="SecurityTokenBase"/> instances are considered equal using value semantics.
		///</summary>
		///<param name="Object1">The first <see cref="SecurityTokenBase"/> to compare.</param>
		///<param name="Object2">The second <see cref="SecurityTokenBase"/> to compare. </param>
		///<returns>true if Object1 is the same instance as Object2 or if both are null references or if objA.Equals(objB) returns true; otherwise, false.</returns>
		public static bool ValueEquals(SecurityTokenBase Object1, SecurityTokenBase Object2)
		{
			// both are null
			if (Object1 == null && Object2 == null)
				return true;

			// one or the other is null, but not both
			if (Object1 == null ^ Object2 == null)
				return false;
				
			bool equal = true;
			if (Object1.TokenKey != Object2.TokenKey)
				equal = false;
			if (Object1.Realm != Object2.Realm)
				equal = false;
			if (Object1.SourceApplication != Object2.SourceApplication)
				equal = false;
			if (Object1.TokenCreated != Object2.TokenCreated)
				equal = false;
			if (Object1.UserName != Object2.UserName)
				equal = false;
					
			return equal;
		}
		
		#endregion
		
		#region IComparable Members
		///<summary>
		/// Compares this instance to a specified object and returns an indication of their relative values.
		///<param name="obj">An object to compare to this instance, or a null reference (Nothing in Visual Basic).</param>
		///</summary>
		///<returns>A signed integer that indicates the relative order of this instance and obj.</returns>
		public virtual int CompareTo(object obj)
		{
			throw new NotImplementedException();
			//return this. GetPropertyName(SourceTable.PrimaryKey.MemberColumns[0]) .CompareTo(((SecurityTokenBase)obj).GetPropertyName(SourceTable.PrimaryKey.MemberColumns[0]));
		}
		
		/*
		// static method to get a Comparer object
        public static SecurityTokenComparer GetComparer()
        {
            return new SecurityTokenComparer();
        }
        */

        // Comparer delegates back to SecurityToken
        // Employee uses the integer's default
        // CompareTo method
        /*
        public int CompareTo(Item rhs)
        {
            return this.Id.CompareTo(rhs.Id);
        }
        */

/*
        // Special implementation to be called by custom comparer
        public int CompareTo(SecurityToken rhs, SecurityTokenColumn which)
        {
            switch (which)
            {
            	
            	
            	case SecurityTokenColumn.TokenKey:
            		return this.TokenKey.CompareTo(rhs.TokenKey);
            		
            		                 
            	
            	
            	case SecurityTokenColumn.Realm:
            		return this.Realm.CompareTo(rhs.Realm);
            		
            		                 
            	
            	
            	case SecurityTokenColumn.SourceApplication:
            		return this.SourceApplication.CompareTo(rhs.SourceApplication);
            		
            		                 
            	
            	
            	case SecurityTokenColumn.TokenCreated:
            		return this.TokenCreated.CompareTo(rhs.TokenCreated);
            		
            		                 
            	
            	
            	case SecurityTokenColumn.UserName:
            		return this.UserName.CompareTo(rhs.UserName);
            		
            		                 
            }
            return 0;
        }
        */
	
		#endregion
		
		#region IComponent Members
		
		private ISite _site = null;

		/// <summary>
		/// Gets or Sets the site where this data is located.
		/// </summary>
		[XmlIgnore]
		[SoapIgnore]
		[Browsable(false)]
		public ISite Site
		{
			get{ return this._site; }
			set{ this._site = value; }
		}

		#endregion

		#region IDisposable Members
		
		/// <summary>
		/// Notify those that care when we dispose.
		/// </summary>
		[field:NonSerialized]
		public event System.EventHandler Disposed;

		/// <summary>
		/// Clean up. Nothing here though.
		/// </summary>
		public virtual void Dispose()
		{
			this.parentCollection = null;
			this.Dispose(true);
			GC.SuppressFinalize(this);
		}
		
		/// <summary>
		/// Clean up.
		/// </summary>
		protected virtual void Dispose(bool disposing)
		{
			if (disposing)
			{
				EventHandler handler = Disposed;
				if (handler != null)
					handler(this, EventArgs.Empty);
			}
		}
		
		#endregion
				
		#region IEntityKey<SecurityTokenKey> Members
		
		// member variable for the EntityId property
		private SecurityTokenKey _entityId;

		/// <summary>
		/// Gets or sets the EntityId property.
		/// </summary>
		[XmlIgnore]
		public virtual SecurityTokenKey EntityId
		{
			get
			{
				if ( _entityId == null )
				{
					_entityId = new SecurityTokenKey(this);
				}

				return _entityId;
			}
			set
			{
				if ( value != null )
				{
					value.Entity = this;
				}
				
				_entityId = value;
			}
		}
		
		#endregion
		
		#region EntityState
		/// <summary>
		///		Indicates state of object
		/// </summary>
		/// <remarks>0=Unchanged, 1=Added, 2=Changed</remarks>
		[BrowsableAttribute(false) , XmlIgnoreAttribute()]
		public override EntityState EntityState 
		{ 
			get{ return entityData.EntityState;	 } 
			set{ entityData.EntityState = value; } 
		}
		#endregion 
		
		#region EntityTrackingKey
		///<summary>
		/// Provides the tracking key for the <see cref="EntityLocator"/>
		///</summary>
		[XmlIgnore]
		public override string EntityTrackingKey
		{
			get
			{
				if(entityTrackingKey == null)
					entityTrackingKey = new System.Text.StringBuilder("SecurityToken")
					.Append("|").Append( this.TokenKey.ToString()).ToString();
				return entityTrackingKey;
			}
			set
		    {
		        if (value != null)
                    entityTrackingKey = value;
		    }
		}
		#endregion 
		
		#region ToString Method
		
		///<summary>
		/// Returns a String that represents the current object.
		///</summary>
		public override string ToString()
		{
			return string.Format(System.Globalization.CultureInfo.InvariantCulture,
				"{6}{5}- TokenKey: {0}{5}- Realm: {1}{5}- SourceApplication: {2}{5}- TokenCreated: {3}{5}- UserName: {4}{5}{7}", 
				this.TokenKey,
				this.Realm,
				this.SourceApplication,
				this.TokenCreated,
				this.UserName,
				System.Environment.NewLine, 
				this.GetType(),
				this.Error.Length == 0 ? string.Empty : string.Format("- Error: {0}\n",this.Error));
		}
		
		#endregion ToString Method
		
		#region Inner data class
		
	/// <summary>
	///		The data structure representation of the 'SecurityToken' table.
	/// </summary>
	/// <remarks>
	/// 	This struct is generated by a tool and should never be modified.
	/// </remarks>
	[EditorBrowsable(EditorBrowsableState.Never)]
	[Serializable]
	internal protected class SecurityTokenEntityData : ICloneable, ICloneableEx
	{
		#region Variable Declarations
		private EntityState currentEntityState = EntityState.Added;
		
		#region Primary key(s)
		/// <summary>			
		/// TokenKey : 
		/// </summary>
		/// <remarks>Member of the primary key of the underlying table "SecurityToken"</remarks>
		public System.Guid TokenKey;
			
		/// <summary>
		/// keep a copy of the original so it can be used for editable primary keys.
		/// </summary>
		public System.Guid OriginalTokenKey;
		
		#endregion
		
		#region Non Primary key(s)
		
		/// <summary>
		/// Realm : 
		/// </summary>
		public System.Guid Realm = Guid.Empty;
		
		/// <summary>
		/// SourceApplication : 
		/// </summary>
		public System.Guid SourceApplication = Guid.Empty;
		
		/// <summary>
		/// TokenCreated : 
		/// </summary>
		public System.DateTime TokenCreated = DateTime.MinValue;
		
		/// <summary>
		/// UserName : 
		/// </summary>
		public System.String UserName = string.Empty;
		#endregion
			
		#region Source Foreign Key Property
				
		private ApplicationDefination _sourceApplicationSource = null;
		
		/// <summary>
		/// Gets or sets the source <see cref="ApplicationDefination"/>.
		/// </summary>
		/// <value>The source ApplicationDefination for SourceApplication.</value>
		[XmlIgnore()]
		[Browsable(false)]
		public virtual ApplicationDefination SourceApplicationSource
      	{
            get { return this._sourceApplicationSource; }
            set { this._sourceApplicationSource = value; }
      	}
		private Realm _realmSource = null;
		
		/// <summary>
		/// Gets or sets the source <see cref="Realm"/>.
		/// </summary>
		/// <value>The source Realm for Realm.</value>
		[XmlIgnore()]
		[Browsable(false)]
		public virtual Realm RealmSource
      	{
            get { return this._realmSource; }
            set { this._realmSource = value; }
      	}
		#endregion
        
		#endregion Variable Declarations

		#region Data Properties

		#endregion Data Properties
		#region Clone Method

		/// <summary>
		/// Creates a new object that is a copy of the current instance.
		/// </summary>
		/// <returns>A new object that is a copy of this instance.</returns>
		public Object Clone()
		{
			SecurityTokenEntityData _tmp = new SecurityTokenEntityData();
						
			_tmp.TokenKey = this.TokenKey;
			_tmp.OriginalTokenKey = this.OriginalTokenKey;
			
			_tmp.Realm = this.Realm;
			_tmp.SourceApplication = this.SourceApplication;
			_tmp.TokenCreated = this.TokenCreated;
			_tmp.UserName = this.UserName;
			
			#region Source Parent Composite Entities
			if (this.SourceApplicationSource != null)
				_tmp.SourceApplicationSource = MakeCopyOf(this.SourceApplicationSource) as ApplicationDefination;
			if (this.RealmSource != null)
				_tmp.RealmSource = MakeCopyOf(this.RealmSource) as Realm;
			#endregion
		
			#region Child Collections
			#endregion Child Collections
			
			//EntityState
			_tmp.EntityState = this.EntityState;
			
			return _tmp;
		}
		
		/// <summary>
		/// Creates a new object that is a copy of the current instance.
		/// </summary>
		/// <returns>A new object that is a copy of this instance.</returns>
		public object Clone(IDictionary existingCopies)
		{
			if (existingCopies == null)
				existingCopies = new Hashtable();
				
			SecurityTokenEntityData _tmp = new SecurityTokenEntityData();
						
			_tmp.TokenKey = this.TokenKey;
			_tmp.OriginalTokenKey = this.OriginalTokenKey;
			
			_tmp.Realm = this.Realm;
			_tmp.SourceApplication = this.SourceApplication;
			_tmp.TokenCreated = this.TokenCreated;
			_tmp.UserName = this.UserName;
			
			#region Source Parent Composite Entities
			if (this.SourceApplicationSource != null && existingCopies.Contains(this.SourceApplicationSource))
				_tmp.SourceApplicationSource = existingCopies[this.SourceApplicationSource] as ApplicationDefination;
			else
				_tmp.SourceApplicationSource = MakeCopyOf(this.SourceApplicationSource, existingCopies) as ApplicationDefination;
			if (this.RealmSource != null && existingCopies.Contains(this.RealmSource))
				_tmp.RealmSource = existingCopies[this.RealmSource] as Realm;
			else
				_tmp.RealmSource = MakeCopyOf(this.RealmSource, existingCopies) as Realm;
			#endregion
		
			#region Child Collections
			#endregion Child Collections
			
			//EntityState
			_tmp.EntityState = this.EntityState;
			
			return _tmp;
		}
		
		#endregion Clone Method
		
		/// <summary>
		///		Indicates state of object
		/// </summary>
		/// <remarks>0=Unchanged, 1=Added, 2=Changed</remarks>
		[BrowsableAttribute(false), XmlIgnoreAttribute()]
		public EntityState	EntityState
		{
			get { return currentEntityState;  }
			set { currentEntityState = value; }
		}
	
	}//End struct

		#endregion
		
				
		
		#region Events trigger
		/// <summary>
		/// Raises the <see cref="ColumnChanging" /> event.
		/// </summary>
		/// <param name="column">The <see cref="SecurityTokenColumn"/> which has raised the event.</param>
		public virtual void OnColumnChanging(SecurityTokenColumn column)
		{
			OnColumnChanging(column, null);
			return;
		}
		
		/// <summary>
		/// Raises the <see cref="ColumnChanged" /> event.
		/// </summary>
		/// <param name="column">The <see cref="SecurityTokenColumn"/> which has raised the event.</param>
		public virtual void OnColumnChanged(SecurityTokenColumn column)
		{
			OnColumnChanged(column, null);
			return;
		} 
		
		
		/// <summary>
		/// Raises the <see cref="ColumnChanging" /> event.
		/// </summary>
		/// <param name="column">The <see cref="SecurityTokenColumn"/> which has raised the event.</param>
		/// <param name="value">The changed value.</param>
		public virtual void OnColumnChanging(SecurityTokenColumn column, object value)
		{
			if(IsEntityTracked && EntityState != EntityState.Added && !EntityManager.TrackChangedEntities)
				EntityManager.StopTracking(entityTrackingKey);
				
			if (!SuppressEntityEvents)
			{
				SecurityTokenEventHandler handler = ColumnChanging;
				if(handler != null)
				{
					handler(this, new SecurityTokenEventArgs(column, value));
				}
			}
		}
		
		/// <summary>
		/// Raises the <see cref="ColumnChanged" /> event.
		/// </summary>
		/// <param name="column">The <see cref="SecurityTokenColumn"/> which has raised the event.</param>
		/// <param name="value">The changed value.</param>
		public virtual void OnColumnChanged(SecurityTokenColumn column, object value)
		{
			if (!SuppressEntityEvents)
			{
				SecurityTokenEventHandler handler = ColumnChanged;
				if(handler != null)
				{
					handler(this, new SecurityTokenEventArgs(column, value));
				}
			
				// warn the parent list that i have changed
				OnEntityChanged();
			}
		} 
		#endregion
			
	} // End Class
	
	
	#region SecurityTokenEventArgs class
	/// <summary>
	/// Provides data for the ColumnChanging and ColumnChanged events.
	/// </summary>
	/// <remarks>
	/// The ColumnChanging and ColumnChanged events occur when a change is made to the value 
	/// of a property of a <see cref="SecurityToken"/> object.
	/// </remarks>
	public class SecurityTokenEventArgs : System.EventArgs
	{
		private SecurityTokenColumn column;
		private object value;
		
		///<summary>
		/// Initalizes a new Instance of the SecurityTokenEventArgs class.
		///</summary>
		public SecurityTokenEventArgs(SecurityTokenColumn column)
		{
			this.column = column;
		}
		
		///<summary>
		/// Initalizes a new Instance of the SecurityTokenEventArgs class.
		///</summary>
		public SecurityTokenEventArgs(SecurityTokenColumn column, object value)
		{
			this.column = column;
			this.value = value;
		}
		
		///<summary>
		/// The SecurityTokenColumn that was modified, which has raised the event.
		///</summary>
		///<value cref="SecurityTokenColumn" />
		public SecurityTokenColumn Column { get { return this.column; } }
		
		/// <summary>
        /// Gets the current value of the column.
        /// </summary>
        /// <value>The current value of the column.</value>
		public object Value{ get { return this.value; } }

	}
	#endregion
	
	///<summary>
	/// Define a delegate for all SecurityToken related events.
	///</summary>
	public delegate void SecurityTokenEventHandler(object sender, SecurityTokenEventArgs e);
	
	#region SecurityTokenComparer
		
	/// <summary>
	///	Strongly Typed IComparer
	/// </summary>
	public class SecurityTokenComparer : System.Collections.Generic.IComparer<SecurityToken>
	{
		SecurityTokenColumn whichComparison;
		
		/// <summary>
        /// Initializes a new instance of the <see cref="T:SecurityTokenComparer"/> class.
        /// </summary>
		public SecurityTokenComparer()
        {            
        }               
        
        /// <summary>
        /// Initializes a new instance of the <see cref="T:SecurityTokenComparer"/> class.
        /// </summary>
        /// <param name="column">The column to sort on.</param>
        public SecurityTokenComparer(SecurityTokenColumn column)
        {
            this.whichComparison = column;
        }

		/// <summary>
        /// Determines whether the specified <see cref="SecurityToken"/> instances are considered equal.
        /// </summary>
        /// <param name="a">The first <see cref="SecurityToken"/> to compare.</param>
        /// <param name="b">The second <c>SecurityToken</c> to compare.</param>
        /// <returns>true if objA is the same instance as objB or if both are null references or if objA.Equals(objB) returns true; otherwise, false.</returns>
        public bool Equals(SecurityToken a, SecurityToken b)
        {
            return this.Compare(a, b) == 0;
        }

		/// <summary>
        /// Gets the hash code of the specified entity.
        /// </summary>
        /// <param name="entity">The entity.</param>
        /// <returns></returns>
        public int GetHashCode(SecurityToken entity)
        {
            return entity.GetHashCode();
        }

        /// <summary>
        /// Performs a case-insensitive comparison of two objects of the same type and returns a value indicating whether one is less than, equal to, or greater than the other.
        /// </summary>
        /// <param name="a">The first object to compare.</param>
        /// <param name="b">The second object to compare.</param>
        /// <returns></returns>
        public int Compare(SecurityToken a, SecurityToken b)
        {
        	EntityPropertyComparer entityPropertyComparer = new EntityPropertyComparer(this.whichComparison.ToString());
        	return entityPropertyComparer.Compare(a, b);
        }

		/// <summary>
        /// Gets or sets the column that will be used for comparison.
        /// </summary>
        /// <value>The comparison column.</value>
        public SecurityTokenColumn WhichComparison
        {
            get { return this.whichComparison; }
            set { this.whichComparison = value; }
        }
	}
	
	#endregion
	
	#region SecurityTokenKey Class

	/// <summary>
	/// Wraps the unique identifier values for the <see cref="SecurityToken"/> object.
	/// </summary>
	[Serializable]
	[CLSCompliant(true)]
	public class SecurityTokenKey : EntityKeyBase
	{
		#region Constructors
		
		/// <summary>
		/// Initializes a new instance of the SecurityTokenKey class.
		/// </summary>
		public SecurityTokenKey()
		{
		}
		
		/// <summary>
		/// Initializes a new instance of the SecurityTokenKey class.
		/// </summary>
		public SecurityTokenKey(SecurityTokenBase entity)
		{
			this.Entity = entity;

			#region Init Properties

			if ( entity != null )
			{
				this.TokenKey = entity.TokenKey;
			}

			#endregion
		}
		
		/// <summary>
		/// Initializes a new instance of the SecurityTokenKey class.
		/// </summary>
		public SecurityTokenKey(System.Guid _tokenKey)
		{
			#region Init Properties

			this.TokenKey = _tokenKey;

			#endregion
		}
		
		#endregion Constructors

		#region Properties
		
		// member variable for the Entity property
		private SecurityTokenBase _entity;
		
		/// <summary>
		/// Gets or sets the Entity property.
		/// </summary>
		public SecurityTokenBase Entity
		{
			get { return _entity; }
			set { _entity = value; }
		}
		
		// member variable for the TokenKey property
		private System.Guid _tokenKey;
		
		/// <summary>
		/// Gets or sets the TokenKey property.
		/// </summary>
		public System.Guid TokenKey
		{
			get { return _tokenKey; }
			set
			{
				if ( this.Entity != null )
					this.Entity.TokenKey = value;
				
				_tokenKey = value;
			}
		}
		
		#endregion

		#region Methods
		
		/// <summary>
		/// Reads values from the supplied <see cref="IDictionary"/> object into
		/// properties of the current object.
		/// </summary>
		/// <param name="values">An <see cref="IDictionary"/> instance that contains
		/// the key/value pairs to be used as property values.</param>
		public override void Load(IDictionary values)
		{
			#region Init Properties

			if ( values != null )
			{
				TokenKey = ( values["TokenKey"] != null ) ? (System.Guid) EntityUtil.ChangeType(values["TokenKey"], typeof(System.Guid)) : Guid.Empty;
			}

			#endregion
		}

		/// <summary>
		/// Creates a new <see cref="IDictionary"/> object and populates it
		/// with the property values of the current object.
		/// </summary>
		/// <returns>A collection of name/value pairs.</returns>
		public override IDictionary ToDictionary()
		{
			IDictionary values = new Hashtable();

			#region Init Dictionary

			values.Add("TokenKey", TokenKey);

			#endregion Init Dictionary

			return values;
		}
		
		///<summary>
		/// Returns a String that represents the current object.
		///</summary>
		public override string ToString()
		{
			return String.Format("TokenKey: {0}{1}",
								TokenKey,
								System.Environment.NewLine);
		}

		#endregion Methods
	}
	
	#endregion	

	#region SecurityTokenColumn Enum
	
	/// <summary>
	/// Enumerate the SecurityToken columns.
	/// </summary>
	[Serializable]
	public enum SecurityTokenColumn : int
	{
		/// <summary>
		/// TokenKey : 
		/// </summary>
		[EnumTextValue("TokenKey")]
		[ColumnEnum("TokenKey", typeof(System.Guid), System.Data.DbType.Guid, true, false, false)]
		TokenKey = 1,
		/// <summary>
		/// Realm : 
		/// </summary>
		[EnumTextValue("Realm")]
		[ColumnEnum("Realm", typeof(System.Guid), System.Data.DbType.Guid, false, false, false)]
		Realm = 2,
		/// <summary>
		/// SourceApplication : 
		/// </summary>
		[EnumTextValue("SourceApplication")]
		[ColumnEnum("SourceApplication", typeof(System.Guid), System.Data.DbType.Guid, false, false, false)]
		SourceApplication = 3,
		/// <summary>
		/// TokenCreated : 
		/// </summary>
		[EnumTextValue("TokenCreated")]
		[ColumnEnum("TokenCreated", typeof(System.DateTime), System.Data.DbType.DateTime, false, false, false)]
		TokenCreated = 4,
		/// <summary>
		/// UserName : 
		/// </summary>
		[EnumTextValue("UserName")]
		[ColumnEnum("UserName", typeof(System.String), System.Data.DbType.String, false, false, false, 1024)]
		UserName = 5
	}//End enum

	#endregion SecurityTokenColumn Enum

} // end namespace
